/*
Copyright Caroline et Serge COUDÉ, (08/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/
package net.sergecoude.TbiGeneral;

import java.util.*;

public class Enchainement {

  private final static long serialVersionUID = 1L;
  
	protected TbiApp _app;
	protected String _nom;
	protected Vector<PanelJeu> _lesTableaux;
	protected Vector<String> _lesIntitules;
	protected int _idxServi = -1;
	protected int _id = 0;
			
	public Enchainement(TbiApp app, String nom, int id) { 
		_app = app;
		_nom = nom;
		_lesTableaux = new Vector<PanelJeu>();
		_lesIntitules = new Vector<String>();
		_idxServi = -1;
		_id = id;
	}
	
	public void reset() {
	 _idxServi = -1;
  }
	
  public String toString() {
    return _nom;
  }

  public String getNom() {
    return _nom;
  }
  
  public int getId() {
    return _id;
  }
  
  public void ajouteTableau(PanelJeu pj, String intitule) {
    _lesTableaux.addElement(pj);
    _lesIntitules.addElement(intitule);
  }
  
  public PanelJeu suivant() {
    _idxServi++;
    if (_lesTableaux.size() > _idxServi)
      return _lesTableaux.elementAt(_idxServi);
    return null; 
  }
  
  public boolean encoreUnAutre() {
    return (_lesTableaux.size()-1 > _idxServi);
  }

  public String getIntitule(PanelJeu pj) {
    for(int i = 0; i < _lesTableaux.size(); i++) 
      if (_lesTableaux.elementAt(i) == pj)
        return _lesIntitules.elementAt(i);
    return ""; 
  }
  
  public void setIntitule(PanelJeu pj, String intitule) {
    for(int i = 0; i < _lesTableaux.size(); i++) 
      if (_lesTableaux.elementAt(i) == pj)
        _lesIntitules.set(i,intitule);
  }  	
  	
}


