/*
Copyright Caroline et Serge COUDÉ, (03/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/

package net.sergecoude.TbiGeneral;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.util.*;

public class JListJButton extends JList {

  private final static long serialVersionUID = 1L;
  
  public JListJButton() {
    super();
  }

  public JListJButton(ListModel dataModel) {
    super(dataModel);
  }
  
  public bouton getBouton(int x, int y) {
    return getBouton(x,y,false);
  }
  
  public bouton getBouton(int x, int y, boolean trace) {
    int currIndex = locationToIndex(new Point(x,y));
    IObjetAvecItem o = (IObjetAvecItem)getSelectedValue();
    Rectangle itemBounds = getCellBounds(currIndex, currIndex);
    if (trace)
      System.out.println("classe item : " + itemBounds);
    if (o != null) {
      JPanel p = o.getItem();    
      if (p != null) {
        try {
          Vector<Component> lesEnfants = getComponents(p, Class.forName("net.sergecoude.TbiGeneral.bouton"));
          if (lesEnfants.size() > 0) {
            if (trace)
              System.out.println("Enumération des 'enfants' :");
            for(int i = 0; i < lesEnfants.size(); i++) {
              bouton bEnf = (bouton)lesEnfants.elementAt(i);
              if (trace)
                System.out.println("pour " + x + "x" + y + " -> " + ((x-itemBounds.x)-bEnf.getX()) + "x" + ((y-itemBounds.y)-bEnf.getY()) + " / " + bEnf);
              if (bEnf.contains((x-itemBounds.x)-bEnf.getX(),(y-itemBounds.y)-bEnf.getY())) {
                return bEnf;
              }
            }
          } else {
            if (trace)
              System.out.println("pas d'enfant !");          
          }
        } catch (ClassNotFoundException cnfe) {
          System.err.println(cnfe);
        }
      } else if (trace) {
        System.out.println("pas d'item d'objet trouvé...");
      }
    } else if (trace) {
      System.out.println("pas d'objet sélectionné...");
    } 
    return null;
  }
  
  public CheckBox getCheckBox(int x, int y) {
    return getCheckBox(x,y,false);
  }
  
  public CheckBox getCheckBox(int x, int y, boolean trace) {
    int currIndex = locationToIndex(new Point(x,y));
    IObjetAvecItem o = (IObjetAvecItem)getSelectedValue();
    Rectangle itemBounds = getCellBounds(currIndex, currIndex);
    if (trace)
      System.out.println("itemBounds : " + itemBounds);
    if (o != null) {
      JPanel p = o.getItem();    
      if (p != null) {
        try {
          Vector<Component> lesEnfants = getComponents(p, Class.forName("net.sergecoude.TbiGeneral.CheckBox"));
          if (lesEnfants.size() > 0) {
            if (trace)
              System.out.println("Enumération des 'enfants' :");
            for(int i = 0; i < lesEnfants.size(); i++) {
              if (trace)
                System.out.println("  - " + lesEnfants.elementAt(i));
              CheckBox bEnf = (CheckBox)lesEnfants.elementAt(i);
              if (trace)
                System.out.println("pour " + x + "x" + y + " -> " + ((x-itemBounds.x)-bEnf.getX()) + "x" + ((y-itemBounds.y)-bEnf.getY()) + " / " + bEnf);
              if (bEnf.contains((x-itemBounds.x)-bEnf.getX(),(y-itemBounds.y)-bEnf.getY())) {
                if (trace)
                  System.out.println("cb trouvee : " + bEnf.getText());
                return bEnf;
              }
            }
          } else {
            if (trace)
              System.out.println("pas d'enfant !");          
          }
        } catch(ClassNotFoundException cnfe) {
          System.err.println(cnfe);
        }
      } else if (trace) {
        System.out.println("pas d'item d'objet trouvé...");
      }
    } else if (trace) {
      System.out.println("pas d'objet sélectionné...");
    } 
    return null;
  }
  
  static public Vector<Component> getComponents(Component composant, Class classeRecherchee) {
    Vector<Component> res = new Vector<Component>();
    if (composant.getClass().equals(classeRecherchee)) {
      res.addElement(composant);
    } else if(composant instanceof Container) {
      Component lesEnfants[] = ((Container)composant).getComponents();
      for(int i = 0; i < lesEnfants.length; i++)  
        res.addAll(getComponents(lesEnfants[i], classeRecherchee));
    }
    return res;
  }
}