/*
Copyright Caroline et Serge COUDÉ, (04/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/
package net.sergecoude.TbiRituel;

import java.util.*;
import net.sergecoude.TbiGeneral.*;

class Constellation extends Vector<Element> {

  private final static long serialVersionUID = 1L;
  protected Element _eIlYAMaison, _eIlYAEcole, _eNbMaison, _eNbEcole, _eEleveALaMaison, _eEleveALEcole;
  protected String _intitule = "";
  protected int _id = 0;
  
  public Constellation(String intitule, int id) {
    super();
    _intitule = intitule;
    _id = id;
  }
  
  public int getNombreElements() {
    int res = size() + 6;
    return res;
  }
  
  public String toString() {
    return _intitule;
  }
  
  public Element getIlYAMaison() {
    return _eIlYAMaison; 
  }
  
  public  Element getIlYAEcole() {
    return _eIlYAEcole;
  }

  public Element getNbMaison() {
    return _eNbMaison;
  }
  
  public Element getNbEcole() {
    return _eNbEcole;
  }
  
  public Element getEleveALaMaison() {
    return _eEleveALaMaison;
  }

  public Element getEleveALEcole() { 
    return _eEleveALEcole;
  }
  
  public void setIlYAMaison(Element e) {
    _eIlYAMaison = e; 
  }
  
  public void setIlYAEcole(Element e) {
    _eIlYAEcole = e;
  }

  public void setNbMaison(Element e) {
    _eNbMaison = e;
  }
  
  public void setNbEcole(Element e) {
    _eNbEcole = e;
  }
  
  public void setEleveALaMaison(Element e) {
    _eEleveALaMaison = e;
  }

  public void setEleveALEcole(Element e) { 
    _eEleveALEcole = e;
  }  
  
  public float setSkin(Skin skin, BarreProgression bProgression, float nbElements, float nbElementsTotal) throws Exception {
    Element e = null;
    String typeConstellation = "img";
    if (_id == TbiRituel._V_CDoigts)
      typeConstellation = "imgDOIGTS";
    if (_id == TbiRituel._V_CCarteAPoints)
      typeConstellation = "imgCAP";
    if (_id == TbiRituel._V_CDes) 
      typeConstellation = "imgDES";
    for(int i = 0; i <= 10; i++) { // on double pour la maison et l'école
      e = elementAt(i*2);
      e.setRessourceImage(skin.getRessource(typeConstellation + Integer.toString(i)));
      e.setRessourceAudio(skin.getRessource("aud" + Integer.toString(i)));
      nbElements++;
      bProgression.setProgression((int)(100f*nbElements/nbElementsTotal));
      e = elementAt(i*2+1);
      e.setRessourceImage(skin.getRessource(typeConstellation + Integer.toString(i)));
      e.setRessourceAudio(skin.getRessource("aud" + Integer.toString(i)));
      nbElements++;
      bProgression.setProgression((int)(100f*nbElements/nbElementsTotal));
    }
    if (_id == TbiRituel._V_CDoigts || _id == TbiRituel._V_CCarteAPoints || _id == TbiRituel._V_CDes) {
      for(int i = 11; i < 14; i++) {
        e = elementAt(i*2);
        e.setRessourceImage(skin.getRessource(typeConstellation + "10"));
        e.setRessourceAudio(skin.getRessource("aud10"));
        nbElements++;
        bProgression.setProgression((int)(100f*nbElements/nbElementsTotal));
        e = elementAt(i*2+1);
        e.setRessourceImage(skin.getRessource(typeConstellation + "10"));
        e.setRessourceAudio(skin.getRessource("aud10"));
        nbElements++;
        bProgression.setProgression((int)(100f*nbElements/nbElementsTotal));
      }
    } else { // nombres
      for(int i = 11; i <= 40; i++) {
        e = elementAt(i*2);
        e.setRessourceImage(skin.getRessource(typeConstellation + Integer.toString(i)));
        e.setRessourceAudio(skin.getRessource("aud" + Integer.toString(i)));
        nbElements++;
        bProgression.setProgression((int)(100f*nbElements/nbElementsTotal));
        e = elementAt(i*2+1);
        e.setRessourceImage(skin.getRessource(typeConstellation + Integer.toString(i)));
        e.setRessourceAudio(skin.getRessource("aud" + Integer.toString(i)));
        nbElements++;
        bProgression.setProgression((int)(100f*nbElements/nbElementsTotal));
       }
    }
    _eIlYAMaison.setRessourceImage(skin.getRessource("imgIlYA"));
    _eIlYAMaison.setRessourceAudio(skin.getRessource("audIlYA"));
    nbElements++;
    bProgression.setProgression((int)(100f*nbElements/nbElementsTotal));
    _eIlYAEcole.setRessourceImage(skin.getRessource("imgIlYA"));
    _eIlYAEcole.setRessourceAudio(skin.getRessource("audIlYA"));
    nbElements++;
    bProgression.setProgression((int)(100f*nbElements/nbElementsTotal));
    _eNbMaison.setRessourceImage(skin.getRessource("imgZoneNumeriqueReporting"));
    _eNbMaison.setRessourceAudio(skin.getRessource("silence"));
    nbElements++;
    bProgression.setProgression((int)(100f*nbElements/nbElementsTotal));
    _eNbEcole.setRessourceImage(skin.getRessource("imgZoneNumeriqueReporting"));
    _eNbEcole.setRessourceAudio(skin.getRessource("silence"));
    nbElements++;
    bProgression.setProgression((int)(100f*nbElements/nbElementsTotal));
    _eEleveALaMaison.setRessourceImage(skin.getRessource("imgEleveALaMaison"));
    _eEleveALaMaison.setRessourceAudio(skin.getRessource("audEleveALaMaison"));
    nbElements++;
    bProgression.setProgression((int)(100f*nbElements/nbElementsTotal));
    _eEleveALEcole.setRessourceImage(skin.getRessource("imgEleveALEcole"));
    _eEleveALEcole.setRessourceAudio(skin.getRessource("audEleveALEcole"));
    nbElements++;
    bProgression.setProgression((int)(100f*nbElements/nbElementsTotal));
    return nbElements;    
  }  
}

public class Constellations {

  private final static long serialVersionUID = 1L;
  
	protected TbiRituel _app;
	protected String _nom;
	protected Vector<Constellation> _lesConstellations;
	protected Constellation _constellationNombres = null;
	protected int _idxServi = -1;
	protected int _id = 0;
			
	public Constellations(TbiRituel app, String nom, int id) { 
		_app = app;
		_nom = nom;
		_lesConstellations = new Vector<Constellation>();
		_idxServi = -1;
		_id = id;
	}

	public void reset() {
	 _idxServi = -1;
  }
	
  public String toString() {
    return _nom;
  }

  public String getNom() {
    return _nom;
  }
  
  public int getId() {
    return _id;
  }

  public void ajouteConstellation(Constellation c) {
    ajouteConstellation(c,false);
  }
  
  public void ajouteConstellation(Constellation c, boolean bConstNombres) {
    if (!bConstNombres) {
      _lesConstellations.addElement(c);
    } else 
      _constellationNombres = c;
  }
  
  public Constellation suivant() {
    _idxServi++;
    if (_lesConstellations.size() > _idxServi)
      return _lesConstellations.elementAt(_idxServi);
    return null; 
  }
  
  public boolean encoreUnAutre() {
    return (_lesConstellations.size()-1 > _idxServi);
  }

  public int getNombreConstellationsSansNombres() {
    return  _lesConstellations.size(); 
  }
  
  public Constellation getConstellationNombres() {
    return _constellationNombres;
  }
  
  public int getNombreConstellations() {
    return  _lesConstellations.size() + (_constellationNombres != null ? 1 : 0); 
  }
  
  public int getNombreElements() {
    int res = 0;
    if (_constellationNombres != null)
      res += _constellationNombres.getNombreElements();
    for(int c = 0; c < _lesConstellations.size(); c++)
      res += _lesConstellations.elementAt(c).getNombreElements();
    return res;
  }
}


