/*
Copyright Caroline et Serge COUDÉ, (04/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/
package net.sergecoude.TbiRituel;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import java.util.*;
import net.sergecoude.TbiGeneral.*;

public class PanelConfigRituel extends PanelConfig {

  private final static long serialVersionUID = 1L;

  private JRadioButton _brAvecNom, _brSansNom;
  private JRadioButton _brAvecJoursCoches, _brSansJoursCoches;
  private PanelConfigRituelEtiquettes _pEtiquettes;
  private JScrollPane _spEtiquettes;
  private JComboBox _cbEnchainement;
  private JComboBox _cbConstellations;
  private Font _police = new Font("SansSerif", Font.BOLD, 22);
	
  public PanelConfigRituel(TbiRituel app) {
    super(app);

		_bUtilClasse.setVisible(false);
    _bNbExercices.setVisible(false);
    _brAvecNom = new JRadioButton("Oui");
		_brAvecNom.setFont(_police);
		_brAvecNom.setOpaque(false);
		if (((TbiRituel)_app).getAvecNomPrononce())
      _brAvecNom.setSelected(true);
    _brSansNom = new JRadioButton("Non");
		_brSansNom.setFont(_police);
		_brSansNom.setOpaque(false);
		if (!((TbiRituel)_app).getAvecNomPrononce())
      _brSansNom.setSelected(true);
    ButtonGroup groupNom = new ButtonGroup();
    groupNom.add(_brAvecNom);
    groupNom.add(_brSansNom);
    JLabel lAvecSansNom = new JLabel("Nom prononcé ?", JLabel.CENTER);
    lAvecSansNom.setFont(_police);
    lAvecSansNom.setOpaque(true);
    lAvecSansNom.setBackground(Color.lightGray);
    JPanel pAvecSansNom = new JPanel(new FlowLayout(FlowLayout.CENTER));
    pAvecSansNom.setOpaque(false);
    pAvecSansNom.add(lAvecSansNom);
    pAvecSansNom.add(_brAvecNom);
    pAvecSansNom.add(_brSansNom);
    pAvecSansNom.setAlignmentX(CENTER_ALIGNMENT);

    _brAvecJoursCoches = new JRadioButton("Oui");
		_brAvecJoursCoches.setFont(_police);
		_brAvecJoursCoches.setOpaque(false);
		if (((TbiRituel)_app).getAvecJoursCoches())
      _brAvecJoursCoches.setSelected(true);
    _brSansJoursCoches = new JRadioButton("Non");
		_brSansJoursCoches.setFont(_police);
		_brSansJoursCoches.setOpaque(false);
		if (!((TbiRituel)_app).getAvecJoursCoches())
      _brSansJoursCoches.setSelected(true);
    ButtonGroup groupJoursCoches = new ButtonGroup();
    groupJoursCoches.add(_brAvecJoursCoches);
    groupJoursCoches.add(_brSansJoursCoches);
    JLabel lAvecSansJoursCoches = new JLabel("Jours précédents cochés ?", JLabel.CENTER);
    lAvecSansJoursCoches.setFont(_police);
    lAvecSansJoursCoches.setOpaque(true);
    lAvecSansJoursCoches.setBackground(Color.lightGray);
    JPanel pAvecSansJoursCoches = new JPanel(new FlowLayout(FlowLayout.CENTER));
    pAvecSansJoursCoches.setOpaque(false);
    pAvecSansJoursCoches.add(lAvecSansJoursCoches);
    pAvecSansJoursCoches.add(_brAvecJoursCoches);
    pAvecSansJoursCoches.add(_brSansJoursCoches);

    JPanel pEnchainement = new JPanel(new FlowLayout(FlowLayout.CENTER));
    pEnchainement.setOpaque(false);
    JLabel lEnchainement = new JLabel("Enchainement des rituels", JLabel.CENTER);
    lEnchainement.setFont(_police);
    lEnchainement.setOpaque(true);
    lEnchainement.setBackground(Color.lightGray);
    pEnchainement.add(lEnchainement);
    _cbEnchainement = new JComboBox();
    _cbEnchainement.setFont(_police);
    _cbEnchainement.setOpaque(true);
    pEnchainement.add(_cbEnchainement);
    
    JPanel pConstellation = new JPanel(new FlowLayout(FlowLayout.CENTER));
    pConstellation.setOpaque(false);
    JLabel lConstellation = new JLabel("Constellations (prés/abs)", JLabel.CENTER);
    lConstellation.setFont(_police);
    lConstellation.setOpaque(true);
    lConstellation.setBackground(Color.lightGray);
    pConstellation.add(lConstellation);
    _cbConstellations = new JComboBox();
    _cbConstellations.setFont(_police);
    _cbConstellations.setOpaque(true);
    initialiseLesConstellations();
    pConstellation.add(_cbConstellations);

    _pEtiquettes = new PanelConfigRituelEtiquettes(_app, this);
    _spEtiquettes = new JScrollPane(_pEtiquettes);        
    
    _pConfExtends.setLayout(new BoxLayout(_pConfExtends, BoxLayout.PAGE_AXIS));
    _pConfExtends.add(pAvecSansNom);
    _pConfExtends.add(Box.createRigidArea(new Dimension(0,10)));
    _pConfExtends.add(pAvecSansJoursCoches);
    _pConfExtends.add(Box.createRigidArea(new Dimension(0,10)));
    _pConfExtends.add(pEnchainement);
    _pConfExtends.add(Box.createRigidArea(new Dimension(0,10)));
    _pConfExtends.add(pConstellation);
    _pConfExtends.add(Box.createRigidArea(new Dimension(0,10)));
    _pConfExtends.add(_spEtiquettes);
  }
  
  protected void preEnregistrer() { // met à jour les config
    super.preEnregistrer();
    ((TbiRituel)_app).setAvecNomPrononce(_brAvecNom.isSelected());
	  ((TbiRituel)_app).setAvecJoursCoches(_brAvecJoursCoches.isSelected());
		((TbiRituel)_app).setAvecElementMeteo(TbiRituel._V_TTresChaud, _pEtiquettes.isSelected(TbiRituel._V_TTresChaud));
		((TbiRituel)_app).setAvecElementMeteo(TbiRituel._V_TChaud, _pEtiquettes.isSelected(TbiRituel._V_TChaud));
		((TbiRituel)_app).setAvecElementMeteo(TbiRituel._V_TTempere, _pEtiquettes.isSelected(TbiRituel._V_TTempere));
		((TbiRituel)_app).setAvecElementMeteo(TbiRituel._V_TFroid, _pEtiquettes.isSelected(TbiRituel._V_TFroid));
		((TbiRituel)_app).setAvecElementMeteo(TbiRituel._V_TTresFroid, _pEtiquettes.isSelected(TbiRituel._V_TTresFroid));
    ((TbiRituel)_app).setAvecElementMeteo(TbiRituel._V_COrage, _pEtiquettes.isSelected(TbiRituel._V_COrage));
    ((TbiRituel)_app).setAvecElementMeteo(TbiRituel._V_CCouvert, _pEtiquettes.isSelected(TbiRituel._V_CCouvert));
    ((TbiRituel)_app).setAvecElementMeteo(TbiRituel._V_CEnsoleilleBlanc, _pEtiquettes.isSelected(TbiRituel._V_CEnsoleilleBlanc));
    ((TbiRituel)_app).setAvecElementMeteo(TbiRituel._V_CBrouillard, _pEtiquettes.isSelected(TbiRituel._V_CBrouillard));
    ((TbiRituel)_app).setAvecElementMeteo(TbiRituel._V_CEnsoleille, _pEtiquettes.isSelected(TbiRituel._V_CEnsoleille));
    ((TbiRituel)_app).setAvecElementMeteo(TbiRituel._V_PSec, _pEtiquettes.isSelected(TbiRituel._V_PSec));
    ((TbiRituel)_app).setAvecElementMeteo(TbiRituel._V_PPluie, _pEtiquettes.isSelected(TbiRituel._V_PPluie));
    ((TbiRituel)_app).setAvecElementMeteo(TbiRituel._V_PAverse, _pEtiquettes.isSelected(TbiRituel._V_PAverse));
    ((TbiRituel)_app).setAvecElementMeteo(TbiRituel._V_PGrele, _pEtiquettes.isSelected(TbiRituel._V_PGrele));
    ((TbiRituel)_app).setAvecElementMeteo(TbiRituel._V_PNeige, _pEtiquettes.isSelected(TbiRituel._V_PNeige));
    ((TbiRituel)_app).setAvecElementMeteo(TbiRituel._V_VNul, _pEtiquettes.isSelected(TbiRituel._V_VNul));
    ((TbiRituel)_app).setAvecElementMeteo(TbiRituel._V_VFort, _pEtiquettes.isSelected(TbiRituel._V_VFort));
    ((TbiRituel)_app).setAvecElementMeteo(TbiRituel._V_VTempete, _pEtiquettes.isSelected(TbiRituel._V_VTempete));
    ((TbiRituel)_app).setEnchainement((Enchainement)_cbEnchainement.getSelectedItem());
    ((TbiRituel)_app).setConstellations(((TbiRituel)_app).getLesConstellations().elementAt(_cbConstellations.getSelectedIndex()));            
  }
  
  public void actionPerformed(ActionEvent evt) {
    super.actionPerformed(evt);
		Object source = evt.getSource();
		if (source == _bEnregistrer) {
		  preEnregistrer();
		  ((TbiRituel)_app).sauveConfiguration(); 
		}
		if (source == _brUtilClasseOui) {
		  metAJourLesEnchainements(true, false);
    }
    if (source == _brUtilClasseNon) {
      metAJourLesEnchainements(false, false);
    }
  }
  
  public void init(boolean defaut) {
    super.init(defaut);
    _bSuivant.setEnabled(true);
    boolean nomprononce = ((TbiRituel)_app).getAvecNomPrononce();
    if (defaut)
      nomprononce = _app.getConfiguration(((TbiRituel)_app)._V_NomPrononce).toLowerCase().equals("oui"); 
    if (nomprononce) 
      _brAvecNom.setSelected(true);
    else
      _brSansNom.setSelected(true);
    boolean jourscoches = ((TbiRituel)_app).getAvecJoursCoches();
    if (defaut)
      jourscoches = _app.getConfiguration(((TbiRituel)_app)._V_JoursCoches).toLowerCase().equals("oui"); 
    if (jourscoches) 
      _brAvecJoursCoches.setSelected(true);
    else
      _brSansJoursCoches.setSelected(true);
    _pEtiquettes.setSelected(TbiRituel._V_TTresChaud, defaut ? _app.getConfiguration(TbiRituel._V_TTresChaud).toLowerCase().equals("oui") : ((TbiRituel)_app).getAvecElementMeteo(TbiRituel._V_TTresChaud));
    _pEtiquettes.setSelected(TbiRituel._V_TChaud, defaut ? _app.getConfiguration(TbiRituel._V_TChaud).toLowerCase().equals("oui") : ((TbiRituel)_app).getAvecElementMeteo(TbiRituel._V_TChaud));
    _pEtiquettes.setSelected(TbiRituel._V_TTempere, defaut ? _app.getConfiguration(TbiRituel._V_TTempere).toLowerCase().equals("oui") : ((TbiRituel)_app).getAvecElementMeteo(TbiRituel._V_TTempere));
    _pEtiquettes.setSelected(TbiRituel._V_TFroid, defaut ? _app.getConfiguration(TbiRituel._V_TFroid).toLowerCase().equals("oui") : ((TbiRituel)_app).getAvecElementMeteo(TbiRituel._V_TFroid));
    _pEtiquettes.setSelected(TbiRituel._V_TTresFroid, defaut ? _app.getConfiguration(TbiRituel._V_TTresFroid).toLowerCase().equals("oui") : ((TbiRituel)_app).getAvecElementMeteo(TbiRituel._V_TTresFroid));
    _pEtiquettes.setSelected(TbiRituel._V_PSec, defaut ? _app.getConfiguration(TbiRituel._V_PSec).toLowerCase().equals("oui") : ((TbiRituel)_app).getAvecElementMeteo(TbiRituel._V_PSec));
    _pEtiquettes.setSelected(TbiRituel._V_PPluie, defaut ? _app.getConfiguration(TbiRituel._V_PPluie).toLowerCase().equals("oui") : ((TbiRituel)_app).getAvecElementMeteo(TbiRituel._V_PPluie));
    _pEtiquettes.setSelected(TbiRituel._V_PAverse, defaut ? _app.getConfiguration(TbiRituel._V_PAverse).toLowerCase().equals("oui") : ((TbiRituel)_app).getAvecElementMeteo(TbiRituel._V_PAverse));
    _pEtiquettes.setSelected(TbiRituel._V_PGrele, defaut ? _app.getConfiguration(TbiRituel._V_PGrele).toLowerCase().equals("oui") : ((TbiRituel)_app).getAvecElementMeteo(TbiRituel._V_PGrele));
    _pEtiquettes.setSelected(TbiRituel._V_PNeige, defaut ? _app.getConfiguration(TbiRituel._V_PNeige).toLowerCase().equals("oui") : ((TbiRituel)_app).getAvecElementMeteo(TbiRituel._V_PNeige));
    _pEtiquettes.setSelected(TbiRituel._V_COrage, defaut ? _app.getConfiguration(TbiRituel._V_COrage).toLowerCase().equals("oui") : ((TbiRituel)_app).getAvecElementMeteo(TbiRituel._V_COrage));
    _pEtiquettes.setSelected(TbiRituel._V_CCouvert, defaut ? _app.getConfiguration(TbiRituel._V_CCouvert).toLowerCase().equals("oui") : ((TbiRituel)_app).getAvecElementMeteo(TbiRituel._V_CCouvert));
    _pEtiquettes.setSelected(TbiRituel._V_CEnsoleilleBlanc, defaut ? _app.getConfiguration(TbiRituel._V_CEnsoleilleBlanc).toLowerCase().equals("oui") : ((TbiRituel)_app).getAvecElementMeteo(TbiRituel._V_CEnsoleilleBlanc));
    _pEtiquettes.setSelected(TbiRituel._V_CBrouillard, defaut ? _app.getConfiguration(TbiRituel._V_CBrouillard).toLowerCase().equals("oui") : ((TbiRituel)_app).getAvecElementMeteo(TbiRituel._V_CBrouillard));
    _pEtiquettes.setSelected(TbiRituel._V_CEnsoleille, defaut ? _app.getConfiguration(TbiRituel._V_CEnsoleille).toLowerCase().equals("oui") : ((TbiRituel)_app).getAvecElementMeteo(TbiRituel._V_CEnsoleille));
    _pEtiquettes.setSelected(TbiRituel._V_VNul, defaut ? _app.getConfiguration(TbiRituel._V_VNul).toLowerCase().equals("oui") : ((TbiRituel)_app).getAvecElementMeteo(TbiRituel._V_VNul));
    _pEtiquettes.setSelected(TbiRituel._V_VFort, defaut ? _app.getConfiguration(TbiRituel._V_VFort).toLowerCase().equals("oui") : ((TbiRituel)_app).getAvecElementMeteo(TbiRituel._V_VFort));
    _pEtiquettes.setSelected(TbiRituel._V_VTempete, defaut ? _app.getConfiguration(TbiRituel._V_VTempete).toLowerCase().equals("oui") : ((TbiRituel)_app).getAvecElementMeteo(TbiRituel._V_VTempete));
    metAJourLesEnchainements(_brUtilClasseOui.isSelected(), defaut);
    int constellation = ((TbiRituel)_app).getConstellations().getId();
    if (defaut)
      constellation = Integer.parseInt(_app.getConfiguration(((TbiRituel)_app)._V_Constellations));
    _cbConstellations.setSelectedIndex(constellation);   
  }
  
  private void metAJourLesEnchainements(boolean tous, boolean defaut) {
    _cbEnchainement.removeAllItems();    
    Vector<Enchainement> lesEnchainements = ((TbiRituel)_app).getLesEnchainements();
    for(int e = 0; e < lesEnchainements.size(); e++)
      if (tous || 
          (lesEnchainements.elementAt(e).getId() != TbiRituel._V_EDateMeteoPresence &&
           lesEnchainements.elementAt(e).getId() != TbiRituel._V_EDatePresenceMeteo &&
           lesEnchainements.elementAt(e).getId() != TbiRituel._V_EMeteoPresenceDate &&
           lesEnchainements.elementAt(e).getId() != TbiRituel._V_EMeteoDatePresence &&
           lesEnchainements.elementAt(e).getId() != TbiRituel._V_EPresenceDateMeteo &&
           lesEnchainements.elementAt(e).getId() != TbiRituel._V_EPresenceMeteoDate &&
           lesEnchainements.elementAt(e).getId() != TbiRituel._V_EDatePresence &&
           lesEnchainements.elementAt(e).getId() != TbiRituel._V_EPresenceDate &&
           lesEnchainements.elementAt(e).getId() != TbiRituel._V_EMeteoPresence &&
           lesEnchainements.elementAt(e).getId() != TbiRituel._V_EPresenceMeteo &&
           lesEnchainements.elementAt(e).getId() != TbiRituel._V_EPresence))
        _cbEnchainement.addItem(lesEnchainements.elementAt(e));
    _cbEnchainement.setSelectedItem(((TbiRituel)_app).getEnchainementParId(defaut ? Integer.parseInt(_app.getConfiguration(TbiRituel._V_Enchainement)) : ((TbiRituel)_app).getEnchainement().getId()));
  }
  
   private void initialiseLesConstellations() {
    _cbConstellations.removeAllItems();    
    Vector<Constellations> lesConstellations = ((TbiRituel)_app).getLesConstellations();
    for(int c = 0; c < lesConstellations.size(); c++) 
      _cbConstellations.addItem(lesConstellations.elementAt(c));
  }
  
  public boolean isSelected(String elem) {
    return _pEtiquettes.isSelected(elem);
  }
  
}
