/*
Copyright Caroline et Serge COUDÉ, (04/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/
package net.sergecoude.TbiRituel;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import java.awt.image.*;
import java.awt.geom.*;
import net.sergecoude.TbiGeneral.*;

public class PanelConfigRituelEtiquettes extends JPanel implements ItemListener {

  private final static long serialVersionUID = 1L;

  private TbiApp _app;
  private PanelConfigRituel _config;
  private JCheckBox _cbTemperature, _cbCiel, _cbPrecipitation, _cbVent;
  private JCheckBox _cbTTresChaud, _cbTChaud, _cbTTempere, _cbTFroid, _cbTTresFroid;
  private JCheckBox _cbCCouvert, _cbCEnsoleille, _cbCEnsoleilleBlanc, _cbCOrage, _cbCBrouillard;
  private JCheckBox _cbPSec,_cbPPluie, _cbPAverse, _cbPGrele, _cbPNeige; 
  private JCheckBox _cbVNul, _cbVFort, _cbVTempete; 
	
  public PanelConfigRituelEtiquettes(TbiApp app, PanelConfigRituel config) {
    _config = config;
    _app = app;
    setLayout(new BorderLayout());
    JPanel pGauche = new JPanel();
    pGauche.setOpaque(true);
    pGauche.setBackground(new Color(180,180,180));
    pGauche.setLayout(new GridLayout(4,1));
    pGauche.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
    add(pGauche, BorderLayout.WEST);
    JPanel pDroit = new JPanel();
    pDroit.setOpaque(false);
    pDroit.setLayout(new GridLayout(4,1));
    add(pDroit, BorderLayout.CENTER);
    setOpaque(true);
    JPanel pTemperature = new JPanel(new FlowLayout(FlowLayout.LEFT));
    pTemperature.setOpaque(false);
    pDroit.add(pTemperature);
    float fRedim = 0.5f;
    try {
      _cbTemperature = new JCheckBox("Température", redimensionne((new ImageIcon(_app.getSkin().getRessource("imgTemperature")).getImage()), fRedim));
      _cbTemperature.setSelectedIcon(selectionneEtRedimensionne((new ImageIcon(_app.getSkin().getRessource("imgTemperature")).getImage()), fRedim));
      configureCB(_cbTemperature);      
      pGauche.add(_cbTemperature);
      _cbTTresChaud = new JCheckBox("Très Chaud", redimensionne((new ImageIcon(_app.getSkin().getRessource("imgTresChaud")).getImage()), fRedim));
      _cbTTresChaud.setSelectedIcon(selectionneEtRedimensionne((new ImageIcon(_app.getSkin().getRessource("imgTresChaud")).getImage()), fRedim));
      configureCB(_cbTTresChaud);            
      pTemperature.add(_cbTTresChaud);
      _cbTChaud = new JCheckBox("Chaud", redimensionne((new ImageIcon(_app.getSkin().getRessource("imgChaud")).getImage()), fRedim));
      _cbTChaud.setSelectedIcon(selectionneEtRedimensionne((new ImageIcon(_app.getSkin().getRessource("imgChaud")).getImage()), fRedim));
      configureCB(_cbTChaud);      
      pTemperature.add(_cbTChaud);
      _cbTTempere = new JCheckBox("Doux", redimensionne((new ImageIcon(_app.getSkin().getRessource("imgTempere")).getImage()), fRedim));
      _cbTTempere.setSelectedIcon(selectionneEtRedimensionne((new ImageIcon(_app.getSkin().getRessource("imgTempere")).getImage()), fRedim));
      configureCB(_cbTTempere);            
      pTemperature.add(_cbTTempere);
      _cbTFroid = new JCheckBox("Froid", redimensionne((new ImageIcon(_app.getSkin().getRessource("imgFroid")).getImage()), fRedim));
      _cbTFroid.setSelectedIcon(selectionneEtRedimensionne((new ImageIcon(_app.getSkin().getRessource("imgFroid")).getImage()), fRedim));
      configureCB(_cbTFroid);      
      pTemperature.add(_cbTFroid);
      _cbTTresFroid = new JCheckBox("Très Froid", redimensionne((new ImageIcon(_app.getSkin().getRessource("imgTresFroid")).getImage()), fRedim));
      _cbTTresFroid.setSelectedIcon(selectionneEtRedimensionne((new ImageIcon(_app.getSkin().getRessource("imgTresFroid")).getImage()), fRedim));
      configureCB(_cbTTresFroid);            
      pTemperature.add(_cbTTresFroid);                
    
      JPanel pCiel = new JPanel(new FlowLayout(FlowLayout.LEFT));
      pCiel.setOpaque(false);
      pDroit.add(pCiel);
      _cbCiel = new JCheckBox("Ciel", redimensionne((new ImageIcon(_app.getSkin().getRessource("imgCiel")).getImage()), fRedim));
      _cbCiel.setSelectedIcon(selectionneEtRedimensionne((new ImageIcon(_app.getSkin().getRessource("imgCiel")).getImage()), fRedim));
      configureCB(_cbCiel);
      pGauche.add(_cbCiel);
      _cbCOrage = new JCheckBox("Orageux", redimensionne((new ImageIcon(_app.getSkin().getRessource("imgOrage")).getImage()), fRedim));
      _cbCOrage.setSelectedIcon(selectionneEtRedimensionne((new ImageIcon(_app.getSkin().getRessource("imgOrage")).getImage()), fRedim));
      configureCB(_cbCOrage);
      pCiel.add(_cbCOrage);
      _cbCCouvert = new JCheckBox("Couvert", redimensionne((new ImageIcon(_app.getSkin().getRessource("imgCouvert")).getImage()), fRedim));
      _cbCCouvert.setSelectedIcon(selectionneEtRedimensionne((new ImageIcon(_app.getSkin().getRessource("imgCouvert")).getImage()), fRedim));
      configureCB(_cbCCouvert);
      pCiel.add(_cbCCouvert);
      _cbCEnsoleilleBlanc = new JCheckBox("Nuages blancs", redimensionne((new ImageIcon(_app.getSkin().getRessource("imgEnsoleilleBlanc")).getImage()), fRedim));
      _cbCEnsoleilleBlanc.setSelectedIcon(selectionneEtRedimensionne((new ImageIcon(_app.getSkin().getRessource("imgEnsoleilleBlanc")).getImage()), fRedim));
      configureCB(_cbCEnsoleilleBlanc);
      pCiel.add(_cbCEnsoleilleBlanc);
      _cbCBrouillard = new JCheckBox("Brouillard", redimensionne((new ImageIcon(_app.getSkin().getRessource("imgBrouillard")).getImage()), fRedim));
      _cbCBrouillard.setSelectedIcon(selectionneEtRedimensionne((new ImageIcon(_app.getSkin().getRessource("imgBrouillard")).getImage()), fRedim));
      configureCB(_cbCBrouillard);
      pCiel.add(_cbCBrouillard);
      _cbCEnsoleille = new JCheckBox("Ensoleillé", redimensionne((new ImageIcon(_app.getSkin().getRessource("imgEnsoleille")).getImage()), fRedim));
      _cbCEnsoleille.setSelectedIcon(selectionneEtRedimensionne((new ImageIcon(_app.getSkin().getRessource("imgEnsoleille")).getImage()), fRedim));
      configureCB(_cbCEnsoleille);
      pCiel.add(_cbCEnsoleille);
    
      JPanel pPrecipitation = new JPanel(new FlowLayout(FlowLayout.LEFT));
      pPrecipitation.setOpaque(false);
      pDroit.add(pPrecipitation);
      _cbPrecipitation = new JCheckBox("Précipitation", redimensionne((new ImageIcon(_app.getSkin().getRessource("imgPrecipitation")).getImage()), fRedim));
      _cbPrecipitation.setSelectedIcon(selectionneEtRedimensionne((new ImageIcon(_app.getSkin().getRessource("imgPrecipitation")).getImage()), fRedim));
      configureCB(_cbPrecipitation);
      pGauche.add(_cbPrecipitation);
      _cbPSec = new JCheckBox("Pas de pluie", redimensionne((new ImageIcon(_app.getSkin().getRessource("imgSec")).getImage()), fRedim));
      _cbPSec.setSelectedIcon(selectionneEtRedimensionne((new ImageIcon(_app.getSkin().getRessource("imgSec")).getImage()), fRedim));
      configureCB(_cbPSec);
      pPrecipitation.add(_cbPSec);
      _cbPPluie = new JCheckBox("Pluie", redimensionne((new ImageIcon(_app.getSkin().getRessource("imgPluie")).getImage()), fRedim));
      _cbPPluie.setSelectedIcon(selectionneEtRedimensionne((new ImageIcon(_app.getSkin().getRessource("imgPluie")).getImage()), fRedim));
      configureCB(_cbPPluie);
      pPrecipitation.add(_cbPPluie);
      _cbPAverse = new JCheckBox("Averses", redimensionne((new ImageIcon(_app.getSkin().getRessource("imgAverse")).getImage()), fRedim));
      _cbPAverse.setSelectedIcon(selectionneEtRedimensionne((new ImageIcon(_app.getSkin().getRessource("imgAverse")).getImage()), fRedim));
      configureCB(_cbPAverse);
      pPrecipitation.add(_cbPAverse);
      _cbPGrele = new JCheckBox("Grêle", redimensionne((new ImageIcon(_app.getSkin().getRessource("imgGrele")).getImage()), fRedim));
      _cbPGrele.setSelectedIcon(selectionneEtRedimensionne((new ImageIcon(_app.getSkin().getRessource("imgGrele")).getImage()), fRedim));
      configureCB(_cbPGrele);
      pPrecipitation.add(_cbPGrele);
      _cbPNeige = new JCheckBox("Neige", redimensionne((new ImageIcon(_app.getSkin().getRessource("imgNeige")).getImage()), fRedim));
      _cbPNeige.setSelectedIcon(selectionneEtRedimensionne((new ImageIcon(_app.getSkin().getRessource("imgNeige")).getImage()), fRedim));
      configureCB(_cbPNeige);
      pPrecipitation.add(_cbPNeige);
    
      JPanel pVent = new JPanel(new FlowLayout(FlowLayout.LEFT));
      pVent.setOpaque(false);
      pDroit.add(pVent);
      _cbVent = new JCheckBox("Vent", redimensionne((new ImageIcon(_app.getSkin().getRessource("imgVent")).getImage()), fRedim));
      _cbVent.setSelectedIcon(selectionneEtRedimensionne((new ImageIcon(_app.getSkin().getRessource("imgVent")).getImage()), fRedim));
      configureCB(_cbVent);
      pGauche.add(_cbVent);
      _cbVNul = new JCheckBox("Pas de vent", redimensionne((new ImageIcon(_app.getSkin().getRessource("imgNul")).getImage()), fRedim));
      _cbVNul.setSelectedIcon(selectionneEtRedimensionne((new ImageIcon(_app.getSkin().getRessource("imgNul")).getImage()), fRedim));
      configureCB(_cbVNul);
      pVent.add(_cbVNul);
      _cbVFort = new JCheckBox("Vent", redimensionne((new ImageIcon(_app.getSkin().getRessource("imgFort")).getImage()), fRedim));
      _cbVFort.setSelectedIcon(selectionneEtRedimensionne((new ImageIcon(_app.getSkin().getRessource("imgFort")).getImage()), fRedim));
      configureCB(_cbVFort);
      pVent.add(_cbVFort);
      _cbVTempete = new JCheckBox("Tempête", redimensionne((new ImageIcon(_app.getSkin().getRessource("imgTempete")).getImage()), fRedim));
      _cbVTempete.setSelectedIcon(selectionneEtRedimensionne((new ImageIcon(_app.getSkin().getRessource("imgTempete")).getImage()), fRedim));
      configureCB(_cbVTempete);
      pVent.add(_cbVTempete);   
    
    } catch(Exception e) {
      _app.messageStatique(e.toString(), _app.MESSAGE_ERREUR);
      e.printStackTrace();
    }    
  }
  
  private void configureCB(JCheckBox cb) {
    cb.setOpaque(false);      
    cb.addItemListener(this);
  }
  
  private ImageIcon redimensionne(Image src, double scale) {
    int w = (int)(scale*src.getWidth(null));
    int h = (int)(scale*src.getHeight(null));
    int type = BufferedImage.TYPE_INT_ARGB;
    BufferedImageOp filter = new RescaleOp(0.7f, 0.7f, null);
    BufferedImage dst = new BufferedImage(w, h, type);
    Graphics2D g2 = dst.createGraphics();
		g2.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BILINEAR);
    g2.setRenderingHint(RenderingHints.KEY_RENDERING, RenderingHints.VALUE_RENDER_QUALITY);
    g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
    g2.setRenderingHint(RenderingHints.KEY_ALPHA_INTERPOLATION, RenderingHints.VALUE_ALPHA_INTERPOLATION_QUALITY);
    g2.setRenderingHint(RenderingHints.KEY_COLOR_RENDERING, RenderingHints.VALUE_COLOR_RENDER_QUALITY);
    g2.setRenderingHint(RenderingHints.KEY_STROKE_CONTROL, RenderingHints.VALUE_STROKE_PURE);
    g2.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
    AlphaComposite composite = AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 0.1f);
    g2.setComposite(composite); 
    g2.drawImage(src, 0, 0, w, h, null);
    g2.dispose();
    return new ImageIcon(filter.filter(dst, dst));
  }
  
  private ImageIcon selectionneEtRedimensionne(Image src, double scale) {
    int w = (int)(scale*src.getWidth(this));
    int h = (int)(scale*src.getHeight(this));
    int type = BufferedImage.TYPE_INT_RGB;
    BufferedImage dst = new BufferedImage(w, h, type);
    Graphics2D g2 = dst.createGraphics();
		g2.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BILINEAR);
    g2.setRenderingHint(RenderingHints.KEY_RENDERING, RenderingHints.VALUE_RENDER_QUALITY);
    g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
    g2.setRenderingHint(RenderingHints.KEY_ALPHA_INTERPOLATION, RenderingHints.VALUE_ALPHA_INTERPOLATION_QUALITY);
    g2.setRenderingHint(RenderingHints.KEY_COLOR_RENDERING, RenderingHints.VALUE_COLOR_RENDER_QUALITY);
    g2.setRenderingHint(RenderingHints.KEY_STROKE_CONTROL, RenderingHints.VALUE_STROKE_PURE);
    g2.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
    g2.drawImage(src, 0, 0, w, h, this);
    g2.dispose();
    return new ImageIcon(dst);
  }  
  
  public void itemStateChanged(ItemEvent evt) {
    JCheckBox src = (JCheckBox)evt.getSource();
    if (src == _cbTemperature) {
      _cbTTresChaud.setSelected(evt.getStateChange() == ItemEvent.SELECTED);
      _cbTChaud.setSelected(evt.getStateChange() == ItemEvent.SELECTED);
      _cbTTempere.setSelected(evt.getStateChange() == ItemEvent.SELECTED);
      _cbTFroid.setSelected(evt.getStateChange() == ItemEvent.SELECTED);
      _cbTTresFroid.setSelected(evt.getStateChange() == ItemEvent.SELECTED);
    }
    if (src == _cbTTresChaud || src == _cbTChaud || src == _cbTTempere || src == _cbTFroid || src == _cbTTresFroid) {
      if ( _cbTTresChaud.isSelected() || _cbTChaud.isSelected() || _cbTTempere.isSelected() || _cbTFroid.isSelected() || _cbTTresFroid.isSelected()) {
        _cbTemperature.removeItemListener(this);
        _cbTemperature.setSelected(true);
        _cbTemperature.addItemListener(this);
      }  
      if ( !_cbTTresChaud.isSelected() && !_cbTChaud.isSelected() && !_cbTTempere.isSelected() && !_cbTFroid.isSelected() && !_cbTTresFroid.isSelected())
        _cbTemperature.setSelected(false);
    }
    if (src == _cbCiel) {
      _cbCOrage.setSelected(evt.getStateChange() == ItemEvent.SELECTED);
      _cbCCouvert.setSelected(evt.getStateChange() == ItemEvent.SELECTED);
      _cbCEnsoleilleBlanc.setSelected(evt.getStateChange() == ItemEvent.SELECTED);
      _cbCBrouillard.setSelected(evt.getStateChange() == ItemEvent.SELECTED);
      _cbCEnsoleille.setSelected(evt.getStateChange() == ItemEvent.SELECTED);
    }
    if (src == _cbCOrage || src == _cbCCouvert || src == _cbCEnsoleilleBlanc || src == _cbCBrouillard || src == _cbCEnsoleille) {
      if ( _cbCOrage.isSelected() || _cbCCouvert.isSelected() || _cbCEnsoleilleBlanc.isSelected() || _cbCBrouillard.isSelected() || _cbCEnsoleille.isSelected()) {
        _cbCiel.removeItemListener(this);
        _cbCiel.setSelected(true);
        _cbCiel.addItemListener(this);
      }  
      if ( !_cbCOrage.isSelected() && !_cbCCouvert.isSelected() && !_cbCEnsoleilleBlanc.isSelected() && !_cbCBrouillard.isSelected() && !_cbCEnsoleille.isSelected())
        _cbCiel.setSelected(false);
    }
    if (src == _cbPrecipitation) {
      _cbPSec.setSelected(evt.getStateChange() == ItemEvent.SELECTED);
      _cbPPluie.setSelected(evt.getStateChange() == ItemEvent.SELECTED);
      _cbPAverse.setSelected(evt.getStateChange() == ItemEvent.SELECTED);
      _cbPGrele.setSelected(evt.getStateChange() == ItemEvent.SELECTED);
      _cbPNeige.setSelected(evt.getStateChange() == ItemEvent.SELECTED);
    }
    if (src == _cbPSec || src == _cbPPluie || src == _cbPAverse || src == _cbPGrele || src == _cbPNeige) {
      if ( _cbPSec.isSelected() || _cbPPluie.isSelected() || _cbPAverse.isSelected() || _cbPGrele.isSelected() || _cbPNeige.isSelected()) {
        _cbPrecipitation.removeItemListener(this);
        _cbPrecipitation.setSelected(true);
        _cbPrecipitation.addItemListener(this);
      }  
      if ( !_cbPSec.isSelected() && !_cbPPluie.isSelected() && !_cbPAverse.isSelected() && !_cbPGrele.isSelected() && !_cbPNeige.isSelected())
        _cbPrecipitation.setSelected(false);
    }
    if (src == _cbVent) {
      _cbVNul.setSelected(evt.getStateChange() == ItemEvent.SELECTED);
      _cbVFort.setSelected(evt.getStateChange() == ItemEvent.SELECTED);
      _cbVTempete.setSelected(evt.getStateChange() == ItemEvent.SELECTED);
    }
    if (src == _cbVNul || src == _cbVFort || src == _cbVTempete) {
      if ( _cbVNul.isSelected() || _cbVFort.isSelected() || _cbVTempete.isSelected()) {
        _cbVent.removeItemListener(this);
        _cbVent.setSelected(true);
        _cbVent.addItemListener(this);
      }  
      if ( !_cbVNul.isSelected() && !_cbVFort.isSelected() && !_cbVTempete.isSelected())
        _cbVent.setSelected(false);
    }
  }
  
  public boolean isSelected(String elem) {
    if (elem.equals("Température")) return _cbTemperature.isSelected();
    if (elem.equals("Ciel")) return _cbCiel.isSelected();
    if (elem.equals("Précipitation")) return _cbPrecipitation.isSelected();
    if (elem.equals("Vent")) return _cbVent.isSelected();
    if (elem.equals(TbiRituel._V_TTresChaud)) return _cbTTresChaud.isSelected();
    if (elem.equals(TbiRituel._V_TChaud)) return _cbTChaud.isSelected();
    if (elem.equals(TbiRituel._V_TTempere)) return _cbTTempere.isSelected();
    if (elem.equals(TbiRituel._V_TFroid)) return _cbTFroid.isSelected();
    if (elem.equals(TbiRituel._V_TTresFroid))  return _cbTTresFroid.isSelected();
    if (elem.equals(TbiRituel._V_CCouvert)) return _cbCCouvert.isSelected();
    if (elem.equals(TbiRituel._V_CEnsoleille)) return _cbCEnsoleille.isSelected();
    if (elem.equals(TbiRituel._V_CEnsoleilleBlanc)) return _cbCEnsoleilleBlanc.isSelected();
    if (elem.equals(TbiRituel._V_COrage)) return _cbCOrage.isSelected();
    if (elem.equals(TbiRituel._V_CBrouillard)) return _cbCBrouillard.isSelected();
    if (elem.equals(TbiRituel._V_PSec)) return _cbPSec.isSelected();
    if (elem.equals(TbiRituel._V_PPluie)) return _cbPPluie.isSelected();
    if (elem.equals(TbiRituel._V_PAverse)) return _cbPAverse.isSelected();
    if (elem.equals(TbiRituel._V_PGrele)) return _cbPGrele.isSelected();
    if (elem.equals(TbiRituel._V_PNeige)) return _cbPNeige.isSelected();
    if (elem.equals(TbiRituel._V_VNul)) return _cbVNul.isSelected();
    if (elem.equals(TbiRituel._V_VFort)) return _cbVFort.isSelected();
    if (elem.equals(TbiRituel._V_VTempete)) return _cbVTempete.isSelected();
    return false;
  }
   
  public void setSelected(String elem, boolean oui) { 
    if (elem.equals(TbiRituel._V_TTresChaud)) _cbTTresChaud.setSelected(oui);
    if (elem.equals(TbiRituel._V_TChaud)) _cbTChaud.setSelected(oui);
    if (elem.equals(TbiRituel._V_TTempere)) _cbTTempere.setSelected(oui);
    if (elem.equals(TbiRituel._V_TFroid)) _cbTFroid.setSelected(oui);
    if (elem.equals(TbiRituel._V_TTresFroid)) _cbTTresFroid.setSelected(oui);
    if (elem.equals(TbiRituel._V_COrage)) _cbCOrage.setSelected(oui);
    if (elem.equals(TbiRituel._V_CCouvert)) _cbCCouvert.setSelected(oui);
    if (elem.equals(TbiRituel._V_CEnsoleilleBlanc)) _cbCEnsoleilleBlanc.setSelected(oui);
    if (elem.equals(TbiRituel._V_CBrouillard)) _cbCBrouillard.setSelected(oui);
    if (elem.equals(TbiRituel._V_CEnsoleille)) _cbCEnsoleille.setSelected(oui);
    if (elem.equals(TbiRituel._V_PSec)) _cbPSec.setSelected(oui);
    if (elem.equals(TbiRituel._V_PPluie)) _cbPPluie.setSelected(oui);
    if (elem.equals(TbiRituel._V_PAverse)) _cbPAverse.setSelected(oui);
    if (elem.equals(TbiRituel._V_PGrele)) _cbPGrele.setSelected(oui);
    if (elem.equals(TbiRituel._V_PNeige)) _cbPNeige.setSelected(oui);
    if (elem.equals(TbiRituel._V_VNul)) _cbVNul.setSelected(oui);
    if (elem.equals(TbiRituel._V_VFort)) _cbVFort.setSelected(oui);
    if (elem.equals(TbiRituel._V_VTempete)) _cbVTempete.setSelected(oui);
  }
  
}
