/*
Copyright Caroline et Serge COUDÉ, (04/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/
package net.sergecoude.TbiRituel;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import java.util.*;
import java.net.*;
import java.awt.image.*;
import javax.imageio.*;
import net.sergecoude.TbiGeneral.*;

public class PanelTableauJeu extends PanelJeuMulti {

  private final static long serialVersionUID = 1L;

  private int _hauteurPoliceAnnee = 30;
  private Font _policeAnnee = new Font("SansSerif", Font.BOLD, _hauteurPoliceAnnee);
  private Element _eJanvier, _eFevrier, _eMars, _eAvril, _eMai, _eJuin, _eJuillet, _eAout, _eSeptembre, _eOctobre, _eNovembre, _eDecembre;
  private Element _eCouleursDesJours;
  private Element _eLundi, _eMardi, _eMercredi, _eJeudi, _eVendredi, _eSamedi, _eDimanche;
  private Element _eHier, _eAujourdhui, _eDemain, _eFleche, _eZsHier, _eZsAujourdhui, _eZsDemain, _eZsMois, _eAnnee;
  private Element _e1, _e2, _e3, _e4, _e5, _e6, _e7, _e8, _e9, _e10, _e11, _e12, _e13, _e14, _e15, _e16, _e17, _e18, _e19, _e20, _e21, _e22, _e23, _e24, _e25, _e26, _e27, _e28, _e29, _e30, _e31;
  private Element _elementSelectionne = null; 
  private bouton _bReset;
  private int _dxMois = 5; // nb de pixels entre deux étiquettes des mois
  private int _dyJours = 5; // nb de pixels entre deux étiquettes des jours
  private int _dxDates = 2; // nb de pixels entre deux étiquettes des dates
  private int _dxSaisie = 10; // nb de pixels horizontaux entre deux étiquettes de la zone saisie
  private int _dySaisie = 10; // nb de pixels verticaux entre deux étiquettes de la zone saisie
  private boolean _moisPlace = false;
  private int _joursPlaces = 0;
  private int _oldZOrder = 3000;
  private int _mouseX;
  private int _mouseY;
  private Calendar _cHier, _cAujourdhui, _cDemain;
  private int _placementsCorrects = 0;

  public PanelTableauJeu(TbiRituel app) {
    super(app);
	// définition de hier, aujourdhui et demain
    _cAujourdhui = Calendar.getInstance();
    _cHier = (Calendar)_cAujourdhui.clone(); 
    _cHier.add(Calendar.DATE, -1);
    _cDemain = (Calendar)_cAujourdhui.clone(); 
    _cDemain.add(Calendar.DATE, 1);

		if (_app.getSkin() == null) {
		  _app.messageStatique("Pas d'habillage (" + _app.getNomDuSkin() + ") trouvé...", _app.MESSAGE_ERREUR);
		  System.exit(-1);
    }
		
		_pMain.setLayout(null); // définition à faire
		// tous les éléments du plateau sont à insérer dans _pMain
  }
  
  @Override
  public void init() {
    if (_init) {
      repaint();
      return;
    }
    centreBarreProgression();
    _bProgression.setBiColors(new Color(128,200,128), Color.white);
    _bProgression.setProgression(0);
    repaint();   
    (new Thread(new Runnable() {
      public void run() {
        float nbElements = 0;
        float nbElementsTotal = 61;
        try {
          _bReset = new bouton(_app.getSkin().getRessource("reset"));
	   	    _bReset.addActionListener(getThis());
  		    _pMain.add(_bReset);
	   	    nbElements++;
	 	      _bProgression.setProgression((int)(100f*nbElements/nbElementsTotal));
        } catch(Exception e) {
          _app.log(e);
        }
        nbElements = creeLesMois((TbiRituel)_app, nbElements, nbElementsTotal);
        try {
          _eCouleursDesJours = new Element((TbiRituel)_app, "CouleursDesJours", _app.getSkin().getRessource("imgComptine"), _app.getSkin().getRessource("audComptine"));      
          _pMain.add(_eCouleursDesJours);
          _eCouleursDesJours.addActionListener(getThis());
          _eCouleursDesJours.setDeplaceable(false);
        } catch(Exception e) {
          _app.log(e);
        }
		    nbElements++;
		    _bProgression.setProgression((int)(100f*nbElements/nbElementsTotal));
        nbElements = creeLesJours((TbiRituel)_app, nbElements, nbElementsTotal);
        nbElements = creeZoneSaisie((TbiRituel)_app, nbElements, nbElementsTotal);
        nbElements = creeLesDates((TbiRituel)_app, nbElements, nbElementsTotal);
        _pEvaluations.setVisible(false);
        _bProgression.setProgression(100);
    	  _app.majAffichage();
        setSouris(true);
        agenceLesComposants();
        SwingUtilities.invokeLater(new Runnable() {
          public void run() {
            retireBarreProgression();
            _init = true;
          }
        });
      };
    })).start();    
  }  
  
  private float creeLesMois(TbiRituel app, float cpt, float cptTotal) {
    try {
      _eJanvier = new Element(app, "Janvier", _app.getSkin().getRessource("imgJanvier"), _app.getSkin().getRessource("audJanvier"));
      _pMain.add(_eJanvier);
      _eJanvier.addActionListener(this);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _eFevrier = new Element(app, "Février", _app.getSkin().getRessource("imgFevrier"), _app.getSkin().getRessource("audFevrier"));
      _pMain.add(_eFevrier);
      _eFevrier.addActionListener(this);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _eMars = new Element(app, "Mars", _app.getSkin().getRessource("imgMars"), _app.getSkin().getRessource("audMars"));
      _pMain.add(_eMars);
      _eMars.addActionListener(this);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _eAvril = new Element(app, "Avril", _app.getSkin().getRessource("imgAvril"), _app.getSkin().getRessource("audAvril"));
      _pMain.add(_eAvril);
      _eAvril.addActionListener(this);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _eMai = new Element(app, "Mai", _app.getSkin().getRessource("imgMai"), _app.getSkin().getRessource("audMai"));
      _pMain.add(_eMai);
      _eMai.addActionListener(this);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _eJuin = new Element(app, "Juin", _app.getSkin().getRessource("imgJuin"), _app.getSkin().getRessource("audJuin"));
      _pMain.add(_eJuin);
      _eJuin.addActionListener(this);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _eJuillet = new Element(app, "Juillet",_app.getSkin().getRessource("imgJuillet"), _app.getSkin().getRessource("audJuillet"));
      _pMain.add(_eJuillet);
      _eJuillet.addActionListener(this);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _eAout = new Element(app, "Août", _app.getSkin().getRessource("imgAout"), _app.getSkin().getRessource("audAout"));
      _pMain.add(_eAout);
      _eAout.addActionListener(this);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _eSeptembre = new Element(app, "Septembre", _app.getSkin().getRessource("imgSeptembre"), _app.getSkin().getRessource("audSeptembre"));
      _pMain.add(_eSeptembre);
      _eSeptembre.addActionListener(this);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _eOctobre = new Element(app, "Octobre", _app.getSkin().getRessource("imgOctobre"), _app.getSkin().getRessource("audOctobre"));
      _pMain.add(_eOctobre);
      _eOctobre.addActionListener(this);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _eNovembre = new Element(app, "Novembre", _app.getSkin().getRessource("imgNovembre"), _app.getSkin().getRessource("audNovembre"));
      _pMain.add(_eNovembre);
      _eNovembre.addActionListener(this);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _eDecembre = new Element(app, "Décembre", _app.getSkin().getRessource("imgDecembre"), _app.getSkin().getRessource("audDecembre"));
      _pMain.add(_eDecembre);
      _eDecembre.addActionListener(this);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      return cpt;      
    } catch(Exception e) {
      app.log(e);
      return cpt;
    }
  }
  
  private float creeLesJours(TbiRituel app, float cpt, float cptTotal) {
    try {
      _eLundi = new Element(app, "Lundi", _app.getSkin().getRessource("imgLundi"), _app.getSkin().getRessource("audLundi"));
      _pMain.add(_eLundi);
      _eLundi.addActionListener(this);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _eMardi = new Element(app, "Mardi", _app.getSkin().getRessource("imgMardi"), _app.getSkin().getRessource("audMardi"));
      _pMain.add(_eMardi);
      _eMardi.addActionListener(this);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _eMercredi = new Element(app, "Mercredi", _app.getSkin().getRessource("imgMercredi"), _app.getSkin().getRessource("audMercredi"));
      _pMain.add(_eMercredi);
      _eMercredi.addActionListener(this);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _eJeudi = new Element(app, "Jeudi", _app.getSkin().getRessource("imgJeudi"), _app.getSkin().getRessource("audJeudi"));
      _pMain.add(_eJeudi);
      _eJeudi.addActionListener(this);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _eVendredi = new Element(app, "Vendredi", _app.getSkin().getRessource("imgVendredi"), _app.getSkin().getRessource("audVendredi"));
      _pMain.add(_eVendredi);
      _eVendredi.addActionListener(this);      
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _eSamedi = new Element(app, "Samedi", _app.getSkin().getRessource("imgSamedi"), _app.getSkin().getRessource("audSamedi"));
      _pMain.add(_eSamedi);
      _eSamedi.addActionListener(this);      
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _eDimanche = new Element(app, "Dimanche", _app.getSkin().getRessource("imgDimanche"), _app.getSkin().getRessource("audDimanche"));
      _pMain.add(_eDimanche);
      _eDimanche.addActionListener(this);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      return cpt;      
    } catch(Exception e) {
      app.log(e);
      return cpt;
    }
  }
  
  private void initElementSaisie(Element e) {
    _pMain.add(e);
    e.addActionListener(this);
    e.setDeplaceable(false);
  }

  private float creeZoneSaisie(TbiRituel app, float cpt, float cptTotal) {
    try {
      _eHier = new Element(app, "Hier", _app.getSkin().getRessource("imgHier"), _app.getSkin().getRessource("audHier"));
      initElementSaisie(_eHier);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _eAujourdhui = new Element(app, "Aujourd'hui", _app.getSkin().getRessource("imgAujourdhui"), _app.getSkin().getRessource("audAujourdhui"));
      initElementSaisie(_eAujourdhui);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _eDemain = new Element(app, "Demain", _app.getSkin().getRessource("imgDemain"), _app.getSkin().getRessource("audDemain"));
      initElementSaisie(_eDemain);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _eFleche = new Element(app, "Flêche", _app.getSkin().getRessource("imgFleche"), _app.getSkin().getRessource("audFleche"));
      initElementSaisie(_eFleche);
      _eFleche.removeActionListener(this);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _eZsHier = new Element(app, "Hier", _app.getSkin().getRessource("imgJour"), _app.getSkin().getRessource("audHier"));
      initElementSaisie(_eZsHier);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _eZsAujourdhui = new Element(app, "Aujourd'hui", _app.getSkin().getRessource("imgJour"), _app.getSkin().getRessource("audAujourdhui"));
      initElementSaisie(_eZsAujourdhui);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _eZsDemain = new Element(app, "Demain", _app.getSkin().getRessource("imgJour"), _app.getSkin().getRessource("audDemain"));
      initElementSaisie(_eZsDemain);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _eZsMois = new Element(app, "Le mois", _app.getSkin().getRessource("imgMois"), _app.getSkin().getRessource("audMois"));
      initElementSaisie(_eZsMois);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      String annee = Integer.toString(_cAujourdhui.get(Calendar.YEAR));
      _eAnnee = new Element(app, annee, _app.getSkin().getRessource("aud" + annee ));
      _eAnnee.setFont(_policeAnnee);
      _eAnnee.setBackground(Color.white);
      _eAnnee.setBorder(BorderFactory.createLineBorder(Color.black));
      initElementSaisie(_eAnnee);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
	    return cpt;
    } catch(Exception e) {
      app.log(e);
      return cpt;
    }
  }
  
  private void initUneDate(Element e) {
    _pMain.add(e);
    e.addActionListener(this);
    e.setDeplaceable(false);
    e.setForeground(Color.red);
  }
  
  private float creeLesDates(TbiRituel app, float cpt, float cptTotal) {
    try {
      _e1 = new Element(app, "1er", _app.getSkin().getRessource("imgDate1"), _app.getSkin().getRessource("audDate1"));
      initUneDate(_e1);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e2 = new Element(app, "2", _app.getSkin().getRessource("imgDate2"), _app.getSkin().getRessource("audDate2"));
      initUneDate(_e2);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e3 = new Element(app, "3", _app.getSkin().getRessource("imgDate3"), _app.getSkin().getRessource("audDate3"));
      initUneDate(_e3);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e4 = new Element(app, "4", _app.getSkin().getRessource("imgDate4"), _app.getSkin().getRessource("audDate4"));
      initUneDate(_e4);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e5 = new Element(app, "5", _app.getSkin().getRessource("imgDate5"), _app.getSkin().getRessource("audDate5"));
      initUneDate(_e5);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e6 = new Element(app, "6", _app.getSkin().getRessource("imgDate6"), _app.getSkin().getRessource("audDate6"));
      initUneDate(_e6);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e7 = new Element(app, "7", _app.getSkin().getRessource("imgDate7"), _app.getSkin().getRessource("audDate7"));
      initUneDate(_e7);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e8 = new Element(app, "8", _app.getSkin().getRessource("imgDate8"), _app.getSkin().getRessource("audDate8"));
      initUneDate(_e8);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e9 = new Element(app, "9", _app.getSkin().getRessource("imgDate9"), _app.getSkin().getRessource("audDate9"));
      initUneDate(_e9);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e10 = new Element(app, "10", _app.getSkin().getRessource("imgDate10"), _app.getSkin().getRessource("audDate10"));
      initUneDate(_e10);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e11 = new Element(app, "11", _app.getSkin().getRessource("imgDate11"), _app.getSkin().getRessource("audDate11"));
      initUneDate(_e11);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e12 = new Element(app, "12", _app.getSkin().getRessource("imgDate12"), _app.getSkin().getRessource("audDate12"));
      initUneDate(_e12);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e13 = new Element(app, "13", _app.getSkin().getRessource("imgDate13"), _app.getSkin().getRessource("audDate13"));
      initUneDate(_e13);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e14 = new Element(app, "14", _app.getSkin().getRessource("imgDate14"), _app.getSkin().getRessource("audDate14"));
      initUneDate(_e14);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e15 = new Element(app, "15", _app.getSkin().getRessource("imgDate15"), _app.getSkin().getRessource("audDate15"));
      initUneDate(_e15);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e16 = new Element(app, "16", _app.getSkin().getRessource("imgDate16"), _app.getSkin().getRessource("audDate16"));
      initUneDate(_e16);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e17 = new Element(app, "17", _app.getSkin().getRessource("imgDate17"), _app.getSkin().getRessource("audDate17"));
      initUneDate(_e17);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e18 = new Element(app, "18", _app.getSkin().getRessource("imgDate18"), _app.getSkin().getRessource("audDate18"));
      initUneDate(_e18);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e19 = new Element(app, "19", _app.getSkin().getRessource("imgDate19"), _app.getSkin().getRessource("audDate19"));
      initUneDate(_e19);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e20 = new Element(app, "20", _app.getSkin().getRessource("imgDate20"), _app.getSkin().getRessource("audDate20"));
      initUneDate(_e20);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e21 = new Element(app, "21", _app.getSkin().getRessource("imgDate21"), _app.getSkin().getRessource("audDate21"));
      initUneDate(_e21);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e22 = new Element(app, "22", _app.getSkin().getRessource("imgDate22"), _app.getSkin().getRessource("audDate22"));
      initUneDate(_e22);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e23 = new Element(app, "23", _app.getSkin().getRessource("imgDate23"), _app.getSkin().getRessource("audDate23"));
      initUneDate(_e23);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e24 = new Element(app, "24", _app.getSkin().getRessource("imgDate24"), _app.getSkin().getRessource("audDate24"));
      initUneDate(_e24);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e25 = new Element(app, "25", _app.getSkin().getRessource("imgDate25"), _app.getSkin().getRessource("audDate25"));
      initUneDate(_e25);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e26 = new Element(app, "26", _app.getSkin().getRessource("imgDate26"), _app.getSkin().getRessource("audDate26"));
      initUneDate(_e26);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e27 = new Element(app, "27", _app.getSkin().getRessource("imgDate27"), _app.getSkin().getRessource("audDate27"));
      initUneDate(_e27);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e28 = new Element(app, "28", _app.getSkin().getRessource("imgDate28"), _app.getSkin().getRessource("audDate28"));
      initUneDate(_e28);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e29 = new Element(app, "29", _app.getSkin().getRessource("imgDate29"), _app.getSkin().getRessource("audDate29"));
      initUneDate(_e29);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e30 = new Element(app, "30", _app.getSkin().getRessource("imgDate30"), _app.getSkin().getRessource("audDate30"));
      initUneDate(_e30);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e31 = new Element(app, "31", _app.getSkin().getRessource("imgDate31"), _app.getSkin().getRessource("audDate31"));
      initUneDate(_e31);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      int nbJours = _cAujourdhui.getActualMaximum(Calendar.DAY_OF_MONTH);
      if (nbJours == 28) {
        _e29.setVisible(false);
        _e30.setVisible(false);
        _e31.setVisible(false);
      } else if (nbJours == 29) {
        _e30.setVisible(false);
        _e31.setVisible(false);
      } else if (nbJours == 30) {
        _e31.setVisible(false);
      }
      return cpt; 
    } catch(Exception e) {
      app.log(e);
      return cpt;
    }
  }
  
  public void actionPerformed(ActionEvent evt) {
		Object source = evt.getSource();
		if (source instanceof Element) {
      Element elem = (Element)source;
      if (((TbiRituel)_app).getAvecNomPrononce() && elem != _elementSelectionne) {
        try {
          _app.play(elem.getURLNom().toURI().toURL());
        } catch (MalformedURLException mue) {
          _app.message(mue.toString(), _app.MESSAGE_ERREUR);
        } catch (URISyntaxException use) {
          _app.message(use.toString(), _app.MESSAGE_ERREUR);
        }
      }
      if (elem != _elementSelectionne && (estCeUneDate(elem) || elem.estDeplaceable())) {
        setElementSelectionne(elem);
      } else {
        setElementSelectionne(null);
      } 
    }
	  if (source == _bReset) {
	    agenceLesComposants();
    }
    if (source instanceof JButton) {
      PanelJeu pj = getPlateau((JButton)source); 
      if (pj != null && pj instanceof PanelTableauMeteo) 
        ((TbiRituel)_app).setPanneau("TableauMeteo");
      if (pj != null && pj instanceof PanelTableauPresence) 
        ((TbiRituel)_app).setPanneau("TableauPresence");
    }
  }
  
  private void agenceDate(Element e, int x, int y, int l, int h) {
    e.setIniLocation(x,y);
    e.setDimension(l, h);
    if (((TbiRituel)_app).getAvecJoursCoches()) {
        if (e.getNom().equals("1er") && _cAujourdhui.get(Calendar.DAY_OF_MONTH) > 1) {
          e.setCoche(true);
          return;
        }
        if (!e.getNom().equals("1er"))    
          if (_cAujourdhui.get(Calendar.DAY_OF_MONTH) > Integer.parseInt(e.getNom())) {
            e.setCoche(true);
            return;
          }
    } 
    e.setCoche(false);
  }
  
 @Override  
  public Dimension getDimBoutonTableau() {
    return new Dimension(80, 20);
  }
 
  @Override 
  public JButton getBoutonPlateau(String libelle) {
    BoutonRituel b = new BoutonRituel(libelle);
    b.addActionListener(this);
    return b;
  }  
  
  @Override
  public void agenceLesComposants() {
    super.agenceLesComposants();
    _moisPlace = false;
	  _joursPlaces = 0;
	  _placementsCorrects = 0;
	  placementsComplets();
    Rectangle dim = getBounds();
    _largeurPlateau = dim.width;
    _hauteurPlateau = dim.height;
    // les mois
    double rLH = (double)_eJanvier.getLargeur() / (double)_eJanvier.getHauteur();
    int lEtiquette, hEtiquette;
    lEtiquette = (_largeurPlateau - 19*_dxMois) / 12; // 4 _dxMois de chaque côté pour la marge 4 + 11 + 4
    hEtiquette = (int)(lEtiquette / rLH);
    int x = 4*_dxMois;
    int y = dim.y + 5;
    _eJanvier.setIniLocation(x,y);
    _eJanvier.setDimension(lEtiquette, hEtiquette);
    x += lEtiquette + _dxMois;
    _eFevrier.setIniLocation(x,y);
    _eFevrier.setDimension(lEtiquette, hEtiquette);    
    x += lEtiquette + _dxMois;
    _eMars.setIniLocation(x,y);
    _eMars.setDimension(lEtiquette, hEtiquette);    
    x += lEtiquette + _dxMois;
    _eAvril.setIniLocation(x,y);
    _eAvril.setDimension(lEtiquette, hEtiquette);    
    x += lEtiquette + _dxMois;
    _eMai.setIniLocation(x,y);
    _eMai.setDimension(lEtiquette, hEtiquette);    
    x += lEtiquette + _dxMois;
    _eJuin.setIniLocation(x,y);
    _eJuin.setDimension(lEtiquette, hEtiquette);    
    x += lEtiquette + _dxMois;
    _eJuillet.setIniLocation(x,y);
    _eJuillet.setDimension(lEtiquette, hEtiquette);    
    x += lEtiquette + _dxMois;
    _eAout.setIniLocation(x,y);
    _eAout.setDimension(lEtiquette, hEtiquette);    
    x += lEtiquette + _dxMois;
    _eSeptembre.setIniLocation(x,y);
    _eSeptembre.setDimension(lEtiquette, hEtiquette);    
    x += lEtiquette + _dxMois;
    _eOctobre.setIniLocation(x,y);
    _eOctobre.setDimension(lEtiquette, hEtiquette);    
    x += lEtiquette + _dxMois;
    _eNovembre.setIniLocation(x,y);
    _eNovembre.setDimension(lEtiquette, hEtiquette);    
    x += lEtiquette + _dxMois;
    _eDecembre.setIniLocation(x,y);
    _eDecembre.setDimension(lEtiquette, hEtiquette);
    figeLesMois(false);
    int yMois = y+hEtiquette;
    int lMois = lEtiquette;
    int hMois = hEtiquette;
    // les dates
    rLH = (double)_e1.getLargeur() / (double)_e1.getHauteur();
    lEtiquette = (_largeurPlateau - _app.getLargeurLogo() - 38*_dxDates) / 31; // 4 _dxDates de chaque côté pour la marge 4 + 30 + 4
    hEtiquette = (int)(lEtiquette / rLH);
    x = _app.getLargeurLogo() + 4*_dxDates;
    y = _hauteurPlateau - 5 - hEtiquette;
    agenceDate(_e1, x, y, lEtiquette, hEtiquette);
    x += lEtiquette + _dxDates;
    agenceDate(_e2, x, y, lEtiquette, hEtiquette);
    x += lEtiquette + _dxDates;
    agenceDate(_e3, x, y, lEtiquette, hEtiquette);
    x += lEtiquette + _dxDates;
    agenceDate(_e4, x, y, lEtiquette, hEtiquette);
    x += lEtiquette + _dxDates;
    agenceDate(_e5, x, y, lEtiquette, hEtiquette);
    x += lEtiquette + _dxDates;
    agenceDate(_e6, x, y, lEtiquette, hEtiquette);
    x += lEtiquette + _dxDates;
    agenceDate(_e7, x, y, lEtiquette, hEtiquette);
    x += lEtiquette + _dxDates;
    agenceDate(_e8, x, y, lEtiquette, hEtiquette);
    x += lEtiquette + _dxDates;
    agenceDate(_e9, x, y, lEtiquette, hEtiquette);
    x += lEtiquette + _dxDates;
    agenceDate(_e10, x, y, lEtiquette, hEtiquette);
    x += lEtiquette + _dxDates;
    agenceDate(_e11, x, y, lEtiquette, hEtiquette);
    x += lEtiquette + _dxDates;
    agenceDate(_e12, x, y, lEtiquette, hEtiquette);
    x += lEtiquette + _dxDates;
    agenceDate(_e13, x, y, lEtiquette, hEtiquette);
    x += lEtiquette + _dxDates;
    agenceDate(_e14, x, y, lEtiquette, hEtiquette);
    x += lEtiquette + _dxDates;
    agenceDate(_e15, x, y, lEtiquette, hEtiquette);
    x += lEtiquette + _dxDates;
    agenceDate(_e16, x, y, lEtiquette, hEtiquette);
    x += lEtiquette + _dxDates;
    agenceDate(_e17, x, y, lEtiquette, hEtiquette);
    x += lEtiquette + _dxDates;
    agenceDate(_e18, x, y, lEtiquette, hEtiquette);
    x += lEtiquette + _dxDates;
    agenceDate(_e19, x, y, lEtiquette, hEtiquette);
    x += lEtiquette + _dxDates;
    agenceDate(_e20, x, y, lEtiquette, hEtiquette);
    x += lEtiquette + _dxDates;
    agenceDate(_e21, x, y, lEtiquette, hEtiquette);
    x += lEtiquette + _dxDates;
    agenceDate(_e22, x, y, lEtiquette, hEtiquette);
    x += lEtiquette + _dxDates;
    agenceDate(_e23, x, y, lEtiquette, hEtiquette);
    x += lEtiquette + _dxDates;
    agenceDate(_e24, x, y, lEtiquette, hEtiquette);
    x += lEtiquette + _dxDates;
    agenceDate(_e25, x, y, lEtiquette, hEtiquette);
    x += lEtiquette + _dxDates;
    agenceDate(_e26, x, y, lEtiquette, hEtiquette);
    x += lEtiquette + _dxDates;
    agenceDate(_e27, x, y, lEtiquette, hEtiquette);
    x += lEtiquette + _dxDates;
    agenceDate(_e28, x, y, lEtiquette, hEtiquette);
    x += lEtiquette + _dxDates;
    agenceDate(_e29, x, y, lEtiquette, hEtiquette);
    x += lEtiquette + _dxDates;
    agenceDate(_e30, x, y, lEtiquette, hEtiquette);
    x += lEtiquette + _dxDates;
    agenceDate(_e31, x, y, lEtiquette, hEtiquette);
    int yDates = y;
    // les jours
    rLH = (double)_eLundi.getLargeur() / (double)_eLundi.getHauteur();
    // premier calcul des dimensions
    lEtiquette = (int)Math.floor((_largeurPlateau - 4*_dyJours - lMois*1.1 - 5*_dxSaisie - _app.getLargeurLogo())/(3*1.2 + 1.1));
    hEtiquette = (int)(lEtiquette / rLH);
    if ((yDates - yMois - 14*_dyJours) / 7 < hEtiquette) {
      // si au final la hauteur du bloc des jours est supérieur à la hauteur possible, on calcule les dimensions des jours selon cette hauteur
      hEtiquette = (yDates - yMois - 14*_dyJours) / 7; // 4 _dyJours de chaque côté pour la marge 4 + 6 + 4
      lEtiquette = (int)(hEtiquette * rLH);
    }  
    x = _largeurPlateau - 4*_dyJours - lEtiquette;
    y = yMois + 4*_dyJours; 
    _eLundi.setIniLocation(x,y);
    _eLundi.setDimension(lEtiquette, hEtiquette);
    y += hEtiquette + _dyJours;
    _eMardi.setIniLocation(x,y);
    _eMardi.setDimension(lEtiquette, hEtiquette);
    y += hEtiquette + _dyJours;
    _eMercredi.setIniLocation(x,y);
    _eMercredi.setDimension(lEtiquette, hEtiquette);
    y += hEtiquette + _dyJours;
    _eJeudi.setIniLocation(x,y);
    _eJeudi.setDimension(lEtiquette, hEtiquette);
    y += hEtiquette + _dyJours;
    _eVendredi.setIniLocation(x,y);
    _eVendredi.setDimension(lEtiquette, hEtiquette);
    y += hEtiquette + _dyJours;
    _eSamedi.setIniLocation(x,y);
    _eSamedi.setDimension(lEtiquette, hEtiquette);
    y += hEtiquette + _dyJours;
    _eDimanche.setIniLocation(x,y);
    _eDimanche.setDimension(lEtiquette, hEtiquette);
    figeLesJours(false);    
    y += hEtiquette + _dyJours;
    int xJours = x;
    int lJours = lEtiquette;
    int hJours = hEtiquette;
    // zone de saisie
    // ZsMois
    int lZsMois = (int)(lMois*1.1);
    int hZsMois = (int)(hMois*1.1);
    int lZsSaisie = (int)(lJours*1.2);
    int hZsSaisie = (int)(hJours*1.2);
    int lZsTotalSaisie = lZsMois + _dxSaisie + 3*lZsSaisie + 2*_dxSaisie + _dxSaisie;
    int xSaisie = _app.getLargeurLogo() + (xJours -_app.getLargeurLogo() - lZsTotalSaisie)/2;    
    _eZsMois.setDimension(lZsMois, hZsMois);
    _eZsMois.setIniLocation(xSaisie, yDates-_dySaisie-hZsMois);
    // Année
    int lAnnee = lZsMois;
    int hAnnee = lAnnee/2;
    _eAnnee.setDimension(lAnnee, hAnnee);
    _eAnnee.setIniLocation(xSaisie, _eZsMois.getY()-_dySaisie-hAnnee);
    if (_app.getAvecTbi()) {
      float surf = 1024 * 768;
      float surfTbi = _app.getLargeurTbi() * _app.getHauteurTbi();
      float ratioPolice = (float)Math.sqrt(surfTbi / surf);
      _eAnnee.setFont(_policeAnnee.deriveFont(_hauteurPoliceAnnee * ratioPolice));
    } 
    
    y = yDates - _dySaisie - hZsSaisie; 
    x = xSaisie + lZsMois + _dxSaisie; 
    _eZsHier.setIniLocation(x,y);
    _eZsHier.setDimension(lZsSaisie, hZsSaisie);
    x += lZsSaisie + _dxSaisie;    
    _eZsAujourdhui.setIniLocation(x,y);
    _eZsAujourdhui.setDimension(lZsSaisie, hZsSaisie);
    x += lZsSaisie + _dxSaisie;    
    _eZsDemain.setIniLocation(x,y);
    _eZsDemain.setDimension(lZsSaisie, hZsSaisie);
    int lFleche = 3*lZsSaisie + 2*_dxSaisie;
    int hFleche = (int)(((double)_eFleche.getHauteur() / (double)_eFleche.getLargeur()) * lFleche);
    y -= _dySaisie + hFleche;
    x = xSaisie + lZsMois + _dxSaisie;
    _eFleche.setIniLocation(x,y);
    _eFleche.setDimension(lFleche, hFleche);
    int yFleche = y; 
    y -= _dySaisie + hEtiquette;
    _eHier.setIniLocation(x,y);
    _eHier.setDimension(lZsSaisie, hZsSaisie);
    x += lZsSaisie + _dxSaisie;
    _eAujourdhui.setIniLocation(x,y);
    _eAujourdhui.setDimension(lZsSaisie, hZsSaisie);
    x += lZsSaisie + _dxSaisie;
    _eDemain.setIniLocation(x,y);
    _eDemain.setDimension(lZsSaisie, hZsSaisie);
    int ySaisie = y;
    // couleurs des jours
    int hTexte = (int)((ySaisie-yMois)*0.9);
    int lTexte = (int)(((double)_eCouleursDesJours.getLargeur() / (double)_eCouleursDesJours.getHauteur()) * hTexte);  
    _eCouleursDesJours.setDimension(lTexte, hTexte);
    _eCouleursDesJours.setIniLocation((_largeurPlateau-_eCouleursDesJours.getLargeur())/2,yMois + (ySaisie-yMois-hTexte)/2);
    // bouton Reset
    Point pIniCdJ = _eCouleursDesJours.getIniLocation();  
    int lReset = pIniCdJ.x-4*_dxMois;
    if (lReset > hTexte)
      lReset = hTexte;
    lReset /= 2;      
    if (lReset < _bReset.getLargeur())
      _bReset.setDimension(lReset, lReset);    
    _bReset.setLocation(4*_dxMois, yMois + (ySaisie-yMois-hTexte)/2);
    repaint();   
  }
  
  public void	eventDispatched(AWTEvent e) {
    if (e instanceof MouseEvent) {
      MouseEvent me = (MouseEvent)e;
      Point p = me.getLocationOnScreen();
      _mouseX = p.x;
      _mouseY = p.y;
      super.eventDispatched(e);
      if (isShowing() && _elementSelectionne != null && _rectEcran != null) {
        Point spotMouse = _elementSelectionne.getSpotMouse();
        Point posParent = _elementSelectionne.getParent().getLocationOnScreen();
        _elementSelectionne.setLocation(_mouseX-posParent.x-spotMouse.x, _mouseY-posParent.y-spotMouse.y);        
      }
    } else {
        super.eventDispatched(e);
    }      
  }
  
  public void setElementSelectionne(Element e) {
    if (e == null) { // on relache l'élément
      if (estCeUnJour(_elementSelectionne)) 
        analyseLesJours(_elementSelectionne);
      if (estCeUnMois(_elementSelectionne)) 
        analyseLesMois(_elementSelectionne);
      if (_elementSelectionne != null)
        _pMain.setComponentZOrder(_elementSelectionne, _oldZOrder);  
    } else { // on vient de cliquer sur l'élément
      if (estCeUneDate(e)) // si c'est une date, on ne la déplace pas 
        analyseLesDates(e);
      else {
        _oldZOrder = _pMain.getComponentZOrder(e);
        _pMain.setComponentZOrder(e, 0);
      }
    }
    _elementSelectionne = e;
  }

  public Element getElementSelectionne() {
    return _elementSelectionne;
  }
  
  private void figeLesJours(boolean b) {
    _eLundi.setDeplaceable(!b);
    _eMardi.setDeplaceable(!b);
    _eMercredi.setDeplaceable(!b);
    _eJeudi.setDeplaceable(!b);
    _eVendredi.setDeplaceable(!b);
    _eSamedi.setDeplaceable(!b);
    _eDimanche.setDeplaceable(!b);
  }

  public boolean estCeUnJour(Element e) {
    return (e == _eLundi ||
            e == _eMardi ||
            e == _eMercredi ||
            e == _eJeudi ||
            e == _eVendredi ||
            e == _eSamedi ||
            e == _eDimanche);                                                            
  }
  
  private boolean adequationJourElement(int j, Element e) {
    return (j == Calendar.MONDAY && e.getNom().equals("Lundi") ||
            j == Calendar.TUESDAY && e.getNom().equals("Mardi") ||
            j == Calendar.WEDNESDAY && e.getNom().equals("Mercredi") ||
            j == Calendar.THURSDAY && e.getNom().equals("Jeudi") ||
            j == Calendar.FRIDAY && e.getNom().equals("Vendredi") ||
            j == Calendar.SATURDAY && e.getNom().equals("Samedi") ||
            j == Calendar.SUNDAY && e.getNom().equals("Dimanche"));
  }
  
  public void analyseLesJours(Element e) {
    Point pIni = e.getIniLocation();
    Element _eZs = null;
    boolean bienPlace = false;
    if (_eZsHier.contient(_mouseX, _mouseY)) {
      _eZs = _eZsHier;
      bienPlace = adequationJourElement(_cHier.get(Calendar.DAY_OF_WEEK), e);
    } else if (_eZsAujourdhui.contient(_mouseX, _mouseY)) {
      _eZs = _eZsAujourdhui;     
      bienPlace = adequationJourElement(_cAujourdhui.get(Calendar.DAY_OF_WEEK), e);
    } else if (_eZsDemain.contient(_mouseX, _mouseY)) {
      _eZs = _eZsDemain;
      bienPlace = adequationJourElement(_cDemain.get(Calendar.DAY_OF_WEEK), e);
    }
    if (!bienPlace)
      e.setLocation(pIni.x, pIni.y);
    else {
      centreElement(_eZs, e);
      e.setDeplaceable(false);
      _joursPlaces++;
      if (_joursPlaces >= 3) {
        figeLesJours(true);
        _placementsCorrects++;
        placementsComplets();
      }
    }
  }
  
  private void figeLesMois(boolean b) {
    _eJanvier.setDeplaceable(!b);
    _eFevrier.setDeplaceable(!b);
    _eMars.setDeplaceable(!b);
    _eAvril.setDeplaceable(!b);
    _eMai.setDeplaceable(!b);
    _eJuin.setDeplaceable(!b);
    _eJuillet.setDeplaceable(!b);
    _eAout.setDeplaceable(!b);
    _eSeptembre.setDeplaceable(!b);
    _eOctobre.setDeplaceable(!b);
    _eNovembre.setDeplaceable(!b);
    _eDecembre.setDeplaceable(!b);
  }
  
  public boolean estCeUnMois(Element e) {
    return (e == _eJanvier ||
            e == _eFevrier ||
            e == _eMars ||
            e == _eAvril ||
            e == _eMai ||
            e == _eJuin ||
            e == _eJuillet ||
            e == _eAout ||
            e == _eSeptembre ||
            e == _eOctobre ||
            e == _eNovembre ||
            e == _eDecembre);                                                            
  }

  private boolean adequationMoisElement(int m, Element e) {
    return (m == Calendar.JANUARY && e.getNom().equals("Janvier") ||
            m == Calendar.FEBRUARY && e.getNom().equals("Février") ||
            m == Calendar.MARCH && e.getNom().equals("Mars") ||
            m == Calendar.APRIL && e.getNom().equals("Avril") ||
            m == Calendar.MAY && e.getNom().equals("Mai") ||
            m == Calendar.JUNE && e.getNom().equals("Juin") ||
            m == Calendar.JULY && e.getNom().equals("Juillet") ||
            m == Calendar.AUGUST && e.getNom().equals("Août") ||
            m == Calendar.SEPTEMBER && e.getNom().equals("Septembre") ||
            m == Calendar.OCTOBER && e.getNom().equals("Octobre") ||
            m == Calendar.NOVEMBER && e.getNom().equals("Novembre") ||
            m == Calendar.DECEMBER && e.getNom().equals("Décembre"));
  }
  
  public void analyseLesMois(Element e) {
    Point pIni = e.getIniLocation();
    boolean bienPlace = false;
    if (_eZsMois.contient(_mouseX, _mouseY)) {
      bienPlace = adequationMoisElement(_cAujourdhui.get(Calendar.MONTH), e);
    }
    if (!bienPlace)
      e.setLocation(pIni.x, pIni.y);
    else {
      _moisPlace = true;
      _placementsCorrects++;
      placementsComplets();
      centreElement(_eZsMois, e);
      e.setDeplaceable(false);
      figeLesMois(true);
    }
  }

  public boolean estCeUneDate(Element e) {
    return (e == _e1 || e == _e2 || e == _e3 || e == _e4 || e == _e5 || e == _e6 || e == _e7 || e == _e8 || e == _e9 || e == _e10 ||
            e == _e11 || e == _e12 || e == _e13 || e == _e14 || e == _e15 || e == _e16 || e == _e17 || e == _e18 || e == _e19 || e == _e20 ||
            e == _e21 || e == _e22 || e == _e23 || e == _e24 || e == _e25 || e == _e26 || e == _e27 || e == _e28 || e == _e29 || e == _e30 ||
            e == _e31);
  }

  private boolean adequationDateElement(int d, Element e) {
    if (e.getNom().equals("1er") && d == 1)
      return true;
    if (!e.getNom().equals("1er"))    
      return (d == Integer.parseInt(e.getNom()));
    return false;  
  }
  
  public void analyseLesDates(Element e) {
    if (adequationDateElement(_cAujourdhui.get(Calendar.DAY_OF_MONTH), e)) {
      e.setCoche(true);
      _placementsCorrects++;
      placementsComplets();
    }
  }
  
  private void centreElement(Element eZs, Element e) {
    Rectangle rEZs = eZs.getBounds();
    Rectangle rE = e.getBounds();
    e.setLocation(rEZs.x+rEZs.width/2-rE.width/2, rEZs.y+rEZs.height/2-rE.height/2);
  }
  
  private boolean placementsComplets() {
    if (_placementsCorrects >= 3) 
      return true;
    return false;
  }  
  
}