/*
Copyright Caroline et Serge COUDÉ, (04/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/
package net.sergecoude.TbiRituel;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import java.util.*;
import java.net.*;
import java.awt.image.*;
import javax.imageio.*;
import net.sergecoude.TbiGeneral.*;

public class PanelTableauPresence extends PanelJeuMulti {

  private final static long serialVersionUID = 1L;
  
  private Element _eMaison; 
  private Element _eEcole; 
  private Element _elementSelectionne = null;
  private Element _e0, _e1, _e2, _e3, _e4, _e5, _e6, _e7, _e8, _e9, _e10, _e11, _e12, _e13, _e14, _e15, _e16, _e17, _e18, _e19, _e20, _e21, _e22, _e23, _e24, _e25, _e26, _e27, _e28, _e29, _e30, _e31, _e32, _e33, _e34, _e35, _e36, _e37, _e38, _e39, _e40;
  private Element _eIlYAMaison, _eIlYAEcole, _eNbMaison, _eNbEcole, _eEleveALaMaison, _eEleveALEcole;
  private int _dyEtiquette = 10; // nb de pixels entre deux rangées d'étiquettes
  private int _dxEtiquette = 5; // nb de pixels entre deux étiquettes 
  private int _oldZOrder = 3000;
  private int _mouseX;
  private int _mouseY;
  private ArrayList<Eleve> _lesEleves = null;
  private Vector<Element> _lesCasesMaison = null;
  private Vector<Element> _lesCasesEcole = null;
  private Vector<Element> _lesElementsEleves = null;
  private Vector<Element> _lesElementsElevesPositionnesMaison = null;
  private Vector<Element> _lesElementsElevesPositionnesEcole = null;
  
  public PanelTableauPresence(TbiRituel app) {
    super(app);

		_pMain.setLayout(null); // définition à faire
		// tous les éléments du plateau sont à insérer dans _pMain
  }
  
  @Override
  public void init() {
    if (_init) {
      repaint();
      return;
    }
    _lesEleves = new ArrayList<Eleve>();
    ArrayList<Eleve> lesElevesDeLaClasse = _app.getClasse().getLesEleves();
    for(int i = 0; i < lesElevesDeLaClasse.size(); i++) {
      if (lesElevesDeLaClasse.get(i).estPresent())
        _lesEleves.add(lesElevesDeLaClasse.get(i));
    }
    final int nbEleves = _lesEleves.size();      
    centreBarreProgression();
    _bProgression.setBiColors(new Color(128,200,128), Color.white);
    _bProgression.setProgression(0);
    repaint();   
    (new Thread(new Runnable() {
      public void run() {
        float nbElements = 0;
        float nbElementsTotal = 2 + 3*nbEleves + 41 + ((TbiRituel)_app).getConstellations().getNombreElements(); 
        nbElements = creeLesEleves((TbiRituel)_app, nbElements, nbElementsTotal);
        nbElements = creeLesCases((TbiRituel)_app, nbElements, nbElementsTotal);
        nbElements = creeLaFileNumerique((TbiRituel)_app, nbElements, nbElementsTotal);
        nbElements = ((TbiRituel)_app).setSkinDesConstellations(_bProgression, nbElements, nbElementsTotal);
        try {
          _eEcole = new Element((TbiRituel)_app, "A l'école", _app.getSkin().getRessource("imgEcole"), _app.getSkin().getRessource("audEcole"));
          _eEcole.addActionListener(getThis());
          _eEcole.setDeplaceable(false);
          _pMain.add(_eEcole);
  		    nbElements++;
	   	    _bProgression.setProgression((int)(100f*nbElements/nbElementsTotal));
          _eMaison = new Element((TbiRituel)_app, "A la maison", _app.getSkin().getRessource("imgMaison"), _app.getSkin().getRessource("audMaison"));
          _eMaison.addActionListener(getThis());
          _eMaison.setDeplaceable(false);
          _pMain.add(_eMaison);          
  		    nbElements++;
	   	    _bProgression.setProgression((int)(100f*nbElements/nbElementsTotal));

        } catch(Exception e) {
          _app.log(e);
        }
        _pEvaluations.setVisible(false);
        _bProgression.setProgression(100);
    	  _app.majAffichage();
        setSouris(true);
        agenceLesComposants();
        SwingUtilities.invokeLater(new Runnable() {
          public void run() {
            retireBarreProgression();
            _init = true;
          }
        });
      };
    })).start();    
  }
  
  private float creeLesCases(TbiRituel app, float cpt, float cptTotal) {
    int nbEleves = /*38; //*/ _lesEleves.size();
    _lesCasesMaison = new Vector<Element>();
    _lesCasesEcole = new Vector<Element>();
    try {
      for(int i = 0; i < (nbEleves <= 10 ? 10 : (nbEleves <= 20 ? 20 : (nbEleves <= 30 ? 30 : (nbEleves <=40 ? 40 : 50)))); i++) {
        Element eCaseMaison = new Element(app, "Case " + (i+1) + " Maison", _app.getSkin().getRessource(i < nbEleves ? "imgCase" : "imgCaseVide"), _app.getSkin().getRessource("audCase"));
        _pMain.add(eCaseMaison);
        _lesCasesMaison.addElement(eCaseMaison);
        cpt++;
  	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
        Element eCaseEcole = new Element(app, "Case " + (i+1) + " Ecole", _app.getSkin().getRessource(i < nbEleves ? "imgCase" : "imgCaseVide"), _app.getSkin().getRessource("audCase"));
        _pMain.add(eCaseEcole);
        _lesCasesEcole.addElement(eCaseEcole);
        cpt++;
  	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
  	  }  
      return cpt;      
    } catch(Exception e) {
      app.log(e);
      return cpt;
    }
  }    

  private float creeLesEleves(TbiRituel app, float cpt, float cptTotal) {
    int nbEleves = _lesEleves.size();
    _lesElementsEleves = new Vector<Element>();
    _lesElementsElevesPositionnesMaison = new Vector<Element>();
    _lesElementsElevesPositionnesEcole = new Vector<Element>();
    try {
      for(int i = 0; i < nbEleves; i++) {
        ItemEleve item = (ItemEleve)(_lesEleves.get(i).getItemEleve());
        Element eEleve = new Element((TbiRituel)_app, item);
        eEleve.setDeplaceable(true);
        eEleve.addActionListener(this);      
        _pMain.add(eEleve);
        _lesElementsEleves.addElement(eEleve);
        cpt++;
  	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
  	  }  
      return cpt;      
    } catch(Exception e) {
      app.log(e);
      return cpt;
    }
  }
  
  private void initUnNombre(Element e) {
    _pMain.add(e);
    e.addActionListener(this);
    e.setDeplaceable(false);
  }
  
  private float creeLaFileNumerique(TbiRituel app, float cpt, float cptTotal) {
    try {
      _e0 = new Element(app, "0", _app.getSkin().getRessource("img0"), _app.getSkin().getRessource("aud0"));
      initUnNombre(_e0);
      cpt++;
      _e1 = new Element(app, "1", _app.getSkin().getRessource("img1"), _app.getSkin().getRessource("aud1"));
      initUnNombre(_e1);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e2 = new Element(app, "2", _app.getSkin().getRessource("img2"), _app.getSkin().getRessource("aud2"));
      initUnNombre(_e2);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e3 = new Element(app, "3", _app.getSkin().getRessource("img3"), _app.getSkin().getRessource("aud3"));
      initUnNombre(_e3);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e4 = new Element(app, "4", _app.getSkin().getRessource("img4"), _app.getSkin().getRessource("aud4"));
      initUnNombre(_e4);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e5 = new Element(app, "5", _app.getSkin().getRessource("img5"), _app.getSkin().getRessource("aud5"));
      initUnNombre(_e5);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e6 = new Element(app, "6", _app.getSkin().getRessource("img6"), _app.getSkin().getRessource("aud6"));
      initUnNombre(_e6);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e7 = new Element(app, "7", _app.getSkin().getRessource("img7"), _app.getSkin().getRessource("aud7"));
      initUnNombre(_e7);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e8 = new Element(app, "8", _app.getSkin().getRessource("img8"), _app.getSkin().getRessource("aud8"));
      initUnNombre(_e8);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e9 = new Element(app, "9", _app.getSkin().getRessource("img9"), _app.getSkin().getRessource("aud9"));
      initUnNombre(_e9);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e10 = new Element(app, "10", _app.getSkin().getRessource("img10"), _app.getSkin().getRessource("aud10"));
      initUnNombre(_e10);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e11 = new Element(app, "11", _app.getSkin().getRessource("img11"), _app.getSkin().getRessource("aud11"));
      initUnNombre(_e11);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e12 = new Element(app, "12", _app.getSkin().getRessource("img12"), _app.getSkin().getRessource("aud12"));
      initUnNombre(_e12);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e13 = new Element(app, "13", _app.getSkin().getRessource("img13"), _app.getSkin().getRessource("aud13"));
      initUnNombre(_e13);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e14 = new Element(app, "14", _app.getSkin().getRessource("img14"), _app.getSkin().getRessource("aud14"));
      initUnNombre(_e14);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e15 = new Element(app, "15", _app.getSkin().getRessource("img15"), _app.getSkin().getRessource("aud15"));
      initUnNombre(_e15);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e16 = new Element(app, "16", _app.getSkin().getRessource("img16"), _app.getSkin().getRessource("aud16"));
      initUnNombre(_e16);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e17 = new Element(app, "17", _app.getSkin().getRessource("img17"), _app.getSkin().getRessource("aud17"));
      initUnNombre(_e17);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e18 = new Element(app, "18", _app.getSkin().getRessource("img18"), _app.getSkin().getRessource("aud18"));
      initUnNombre(_e18);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e19 = new Element(app, "19", _app.getSkin().getRessource("img19"), _app.getSkin().getRessource("aud19"));
      initUnNombre(_e19);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e20 = new Element(app, "20", _app.getSkin().getRessource("img20"), _app.getSkin().getRessource("aud20"));
      initUnNombre(_e20);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e21 = new Element(app, "21", _app.getSkin().getRessource("img21"), _app.getSkin().getRessource("aud21"));
      initUnNombre(_e21);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e22 = new Element(app, "22", _app.getSkin().getRessource("img22"), _app.getSkin().getRessource("aud22"));
      initUnNombre(_e22);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e23 = new Element(app, "23", _app.getSkin().getRessource("img23"), _app.getSkin().getRessource("aud23"));
      initUnNombre(_e23);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e24 = new Element(app, "24", _app.getSkin().getRessource("img24"), _app.getSkin().getRessource("aud24"));
      initUnNombre(_e24);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e25 = new Element(app, "25", _app.getSkin().getRessource("img25"), _app.getSkin().getRessource("aud25"));
      initUnNombre(_e25);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e26 = new Element(app, "26", _app.getSkin().getRessource("img26"), _app.getSkin().getRessource("aud26"));
      initUnNombre(_e26);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e27 = new Element(app, "27", _app.getSkin().getRessource("img27"), _app.getSkin().getRessource("aud27"));
      initUnNombre(_e27);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e28 = new Element(app, "28", _app.getSkin().getRessource("img28"), _app.getSkin().getRessource("aud28"));
      initUnNombre(_e28);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e29 = new Element(app, "29", _app.getSkin().getRessource("img29"), _app.getSkin().getRessource("aud29"));
      initUnNombre(_e29);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e30 = new Element(app, "30", _app.getSkin().getRessource("img30"), _app.getSkin().getRessource("aud30"));
      initUnNombre(_e30);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e31 = new Element(app, "31", _app.getSkin().getRessource("img31"), _app.getSkin().getRessource("aud31"));
      initUnNombre(_e31);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e32 = new Element(app, "32", _app.getSkin().getRessource("img32"), _app.getSkin().getRessource("aud32"));
      initUnNombre(_e32);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e33 = new Element(app, "33", _app.getSkin().getRessource("img33"), _app.getSkin().getRessource("aud33"));
      initUnNombre(_e33);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e34 = new Element(app, "34", _app.getSkin().getRessource("img34"), _app.getSkin().getRessource("aud34"));
      initUnNombre(_e34);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e35 = new Element(app, "35", _app.getSkin().getRessource("img35"), _app.getSkin().getRessource("aud35"));
      initUnNombre(_e35);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e36 = new Element(app, "36", _app.getSkin().getRessource("img36"), _app.getSkin().getRessource("aud36"));
      initUnNombre(_e36);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e37 = new Element(app, "37", _app.getSkin().getRessource("img37"), _app.getSkin().getRessource("aud37"));
      initUnNombre(_e37);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e38 = new Element(app, "38", _app.getSkin().getRessource("img38"), _app.getSkin().getRessource("aud38"));
      initUnNombre(_e38);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e39 = new Element(app, "39", _app.getSkin().getRessource("img39"), _app.getSkin().getRessource("aud39"));
      initUnNombre(_e39);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      _e40 = new Element(app, "40", _app.getSkin().getRessource("img40"), _app.getSkin().getRessource("aud40"));
      initUnNombre(_e40);
      cpt++;
	    _bProgression.setProgression((int)(100f*cpt/cptTotal));
      return cpt; 
    } catch(Exception e) {
      app.log(e);
      return cpt;
    }
  }      
  
  public void actionPerformed(ActionEvent evt) {
		Object source = evt.getSource();
		if (source instanceof Element) {
      Element elem = (Element)source;
      if (((TbiRituel)_app).getAvecNomPrononce() && elem != _elementSelectionne) {
        try {
          if (elem.getURLNom() != null)
            _app.play(elem.getURLNom().toURI().toURL());
          else
            _app.play(elem.getAudio()); 
        } catch (MalformedURLException mue) {
          _app.message(mue.toString(), _app.MESSAGE_ERREUR);
        } catch (URISyntaxException use) {
          _app.message(use.toString(), _app.MESSAGE_ERREUR);
        }
      }
      if (elem != _elementSelectionne && elem.estDeplaceable()) {
        setElementSelectionne(elem);
      } else {
        setElementSelectionne(null);
      } 
    }
    if (source instanceof JButton) {
      PanelJeu pj = getPlateau((JButton)source); 
      if (pj != null && pj instanceof PanelTableauMeteo) 
        ((TbiRituel)_app).setPanneau("TableauMeteo");
      if (pj != null && pj instanceof PanelTableauJeu) 
        ((TbiRituel)_app).setPanneau("TableauJeu");
    }
  }
  
 @Override  
  public Dimension getDimBoutonTableau() {
    return new Dimension(80, 20);
  }
 
  @Override 
  public JButton getBoutonPlateau(String libelle) {
    BoutonRituel b = new BoutonRituel(libelle);
    b.addActionListener(this);
    return b;
  }
  
  private void agenceNombre(Element e, int x, int y, int l, int h) {
    e.setIniLocation(x,y);
    e.setIniDimension(l, h);
    e.setCoche(false);
  }    
  
  @Override
  public void agenceLesComposants() {
    super.agenceLesComposants();
    // calcul des dimensions 
    Rectangle dim = getBounds();
    _largeurPlateau = dim.width;
    _hauteurPlateau = dim.height;
 
    double rLH = (double)_eEcole.getLargeur() / (double)_eEcole.getHauteur();
    int lZoneSaisie = 2*_largeurPlateau/5;
    int hZoneSaisie = (int)(lZoneSaisie/rLH);
    //int dxZoneSaisie = (_largeurPlateau-2*lZoneSaisie)/4;
    int dxZoneSaisie = 0;
    
    _eMaison.setIniDimension(lZoneSaisie, hZoneSaisie);
    _eMaison.setIniLocation(dxZoneSaisie,dim.y);
    
    _eEcole.setIniDimension(lZoneSaisie, hZoneSaisie);
    _eEcole.setIniLocation(2*dxZoneSaisie+lZoneSaisie,dim.y);

    // agencement des cases
    float ratio = (float)ItemEleve.ratio;
    int nbEleves = /*38; //*/ _lesEleves.size();
    int nbBloc10 = nbEleves / 10;
    nbBloc10 += (nbBloc10*10 != nbEleves) ? 1 : 0;
    int hBloc10, lBloc10, dyBloc10, dxBloc10, hCase, lCase, margeHorizontale;
    Point posIniMaison = _eMaison.getIniLocation();
    Point posIniEcole = _eEcole.getIniLocation();
    if (nbBloc10 <= 3) { // calcul par rapport à la hauteur
      hBloc10 = (int)(hZoneSaisie * 0.9f / nbBloc10);
      dyBloc10 = (int)(hZoneSaisie * 0.1f /(nbBloc10+1));
      hCase = hBloc10/2;
      lCase = (int)(hCase*ratio);
      lBloc10 = 5*lCase;
      dxBloc10 = (lZoneSaisie-lBloc10) / 2;
      margeHorizontale = posIniMaison.x + (lZoneSaisie-lBloc10)/2;
    } else { // calcul par rapport à la largeur           
      lBloc10 = (int)(lZoneSaisie * 0.9f / 2);
      dxBloc10 = (int)(lZoneSaisie * 0.1f / 3);
      lCase = lBloc10/5;
      hCase = (int)(lCase/ratio);
      hBloc10 = 2*hCase;
      dyBloc10 = (hZoneSaisie - 2*hBloc10)/3;
      margeHorizontale = posIniMaison.x + dxBloc10;      
    } 
    int x = margeHorizontale;
    int y = posIniMaison.y + dyBloc10;
    for(int b = 0; b < nbBloc10; b++) {
      for(int i = 0; i < 5; i++) {
        for(int j = 0; j < 2; j++) {
          int n = (b*10)+(i*2)+j;
          Element eCaseMaison = _lesCasesMaison.elementAt(n);
          eCaseMaison.setIniDimension(lCase, hCase);
          eCaseMaison.setIniLocation(x+(i*lCase),y+(j*hCase));
          Element eCaseEcole = _lesCasesEcole.elementAt(n);
          eCaseEcole.setIniDimension(lCase, hCase);
          eCaseEcole.setIniLocation(lZoneSaisie+x+(i*lCase),y+(j*hCase));
        }
      }
      if (nbBloc10 > 3) {
        if (b % 2 == 0) {
          x +=  lBloc10 + dxBloc10;
        } else {
          x = margeHorizontale; 
          y += 2*hCase+dyBloc10;
        }
      } else {
        y += 2*hCase+dyBloc10;
      }
      placementsComplets();
    }
    
    /* // ancienne disposition en bas
    Dimension dimLogo = _app.getDimensionLogo();
    int l = 0, c = 0;
    try {
      for(int e = 0; e < nbEleves; e++) {
        if (dimLogo.width+(c+1)*lCase > _largeurPlateau) {
          c = 0;
          l++;
        }
        Element eEleve = _lesElementsEleves.elementAt(e);
        eEleve.setIniDimension(lCase,hCase);
        eEleve.setIniLocation(dimLogo.width+c*lCase, hZoneSaisie+l*hCase);
        c++; 
      }
    } catch(Exception e) {  
      _app.message(e, _app.MESSAGE_ERREUR);
    }*/
          
    // Disposition des élèves dans les cases de la maison
    for(int e = 0; e < nbEleves; e++) {
      Element eEleve = _lesElementsEleves.elementAt(e);
      eEleve.setIniDimension(lCase,hCase);
      Rectangle rEZs = _lesCasesMaison.elementAt(e).getBounds();
      eEleve.setIniLocation(rEZs.x+rEZs.width/2-lCase/2, rEZs.y+rEZs.height/2-hCase/2);
      _lesElementsElevesPositionnesMaison.addElement(eEleve);
    }
    // la file numérique
    rLH = (double)_e1.getLargeur() / (double)_e1.getHauteur();
    int lEtiquette = (_largeurPlateau - _app.getLargeurLogo()) / 41;  
    int hEtiquette = (int)(lEtiquette / rLH);
    x = _app.getLargeurLogo();
    y = _hauteurPlateau - hEtiquette;
    agenceNombre(_e0, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e1, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e2, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e3, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e4, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e5, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e6, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e7, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e8, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e9, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e10, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e11, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e12, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e13, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e14, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e15, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e16, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e17, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e18, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e19, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e20, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e21, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e22, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e23, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e24, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e25, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e26, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e27, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e28, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e29, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e30, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e31, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e32, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e33, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e34, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e35, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e36, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e37, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e38, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e39, x, y, lEtiquette, hEtiquette);
    x += lEtiquette;
    agenceNombre(_e40, x, y, lEtiquette, hEtiquette);
    
    // les constellations
    Constellations constellations = ((TbiRituel)_app).getConstellations();
    // les nombres
    Constellation constellationNombres = constellations.getConstellationNombres();
    if (constellationNombres != null) {
       y -= (hEtiquette*1.1); // on met les nombres au dessus de la file numérique
       x = _app.getLargeurLogo(); 
      for (int i = 0; i < 41; i++) {
        Element element = constellationNombres.elementAt(i*2);
        element.setDeplaceable(true);
        element.addActionListener(this); 
        _pMain.add(element);
        agenceNombre(element, x, y, (int)(lEtiquette*0.9), (int)(hEtiquette*0.9));
        // on superpose
        element = constellationNombres.elementAt((i*2)+1);
        element.setDeplaceable(true);
        element.addActionListener(this); 
        _pMain.add(element);
        agenceNombre(element, x, y, (int)(lEtiquette*0.9), (int)(hEtiquette*0.9));
        x += lEtiquette;
      }
    }
    // les autres constellations
    int nbConstellations = constellations.getNombreConstellationsSansNombres();
    int hZoneConstellations = y-posIniEcole.y;
    int hZoneReporting = y-(posIniEcole.y+hZoneSaisie);
    int lZoneReporting = posIniEcole.x+lZoneSaisie;
    int lZoneConstellations = _largeurPlateau-(posIniEcole.x+lZoneSaisie);
    float ratioLHZoneConstellations = (float)lZoneConstellations / (float) hZoneConstellations;
    float ratioLHConstellations = (float)nbConstellations / 11f; // ce sont des carrés
    float coefReduc = 0.9f;
    if (ratioLHZoneConstellations > ratioLHConstellations) { // on se cale sur la hauteur
        hEtiquette = hZoneConstellations / 11;
        hEtiquette *= coefReduc;
        lEtiquette = hEtiquette;
    } else { // on se cale sur la largeur
        lEtiquette = lZoneConstellations / nbConstellations;
        lEtiquette *= coefReduc;
        hEtiquette = lEtiquette;
    }
    int dxEtiquette = (lZoneConstellations-(nbConstellations*lEtiquette))/(nbConstellations+1);
    int dyEtiquette = (hZoneConstellations-(11*hEtiquette))/12;
    constellations.reset();
    Constellation constellation = constellations.suivant();
    x = posIniEcole.x+lZoneSaisie+dxEtiquette;
    y = posIniEcole.y - (hEtiquette+dyEtiquette);
    while(constellation != null) {
      for (int i = 0; i < 11; i++) {
        y += hEtiquette+dyEtiquette;
        Element element = constellation.elementAt(i*2); 
        _pMain.add(element);
        agenceNombre(element, x, y, lEtiquette, hEtiquette);
        element.setDeplaceable(true);
        element.addActionListener(this);
        // on superpose
        element = constellation.elementAt((i*2)+1); 
        _pMain.add(element);
        agenceNombre(element, x, y, lEtiquette, hEtiquette);
        element.setDeplaceable(true);
        element.addActionListener(this); 
      }
      // on superpose 10, 20, 30 et 40
      for (int i = 11; i < 14; i++) {
        Element element = constellation.elementAt(i*2); 
        _pMain.add(element);
        agenceNombre(element, x, y, lEtiquette, hEtiquette);
        element.setDeplaceable(true);
        element.addActionListener(this);
        // on superpose
        element = constellation.elementAt((i*2)+1); 
        _pMain.add(element);
        agenceNombre(element, x, y, lEtiquette, hEtiquette);
        element.setDeplaceable(true);
        element.addActionListener(this); 
      }
      y = posIniEcole.y - (hEtiquette+dyEtiquette); 
      x += dxEtiquette + lEtiquette;
      constellation = constellations.suivant();  
    }
    // on set au moins une constellation
    if (constellationNombres != null) 
      constellation = constellationNombres;
    else {
      constellations.reset();
      constellation = constellations.suivant();
    }  
    // le reporting
    int dxZoneReporting = (int)(lZoneSaisie*0.05);
    int dyZoneReporting = (int)(hZoneReporting*0.05);
    int lZoneReporting2 = (lZoneSaisie-2*dxZoneReporting)-4*lEtiquette-lEtiquette;
    float reducReporting = (float)lZoneReporting2 / (float)(constellation.getIlYAMaison().getLargeur()+constellation.getEleveALaMaison().getLargeur());
    if ((float)lZoneReporting2 / (float)(constellation.getIlYAEcole().getLargeur()+constellation.getEleveALEcole().getLargeur()) < reducReporting)
      reducReporting = (float)lZoneReporting2 / (float)(constellation.getIlYAEcole().getLargeur()+constellation.getEleveALEcole().getLargeur());
      
    y = posIniMaison.y+hZoneSaisie+(hZoneReporting-4*hEtiquette)/2; // on centre les reporting verticalement
    y += agenceLeReporting(constellationNombres, posIniMaison, posIniEcole, dxZoneReporting, dyZoneReporting, lZoneReporting2, reducReporting, lEtiquette, hEtiquette, y, hZoneSaisie, lZoneSaisie);
    constellations.reset();
    constellation = constellations.suivant();
    while(constellation != null) {
      y += agenceLeReporting(constellation, posIniMaison, posIniEcole, dxZoneReporting, dyZoneReporting, lZoneReporting2, reducReporting, lEtiquette, hEtiquette, y, hZoneSaisie, lZoneSaisie);    
      constellation = constellations.suivant();  
    }    
    repaint();   
  }
  
  private int agenceLeReporting(Constellation constellation, Point posIniMaison, Point posIniEcole, int dxZoneReporting, int dyZoneReporting, int lZoneReporting2, float reducReporting, int lEtiquette, int hEtiquette, int y, int hZoneSaisie, int lZoneSaisie) {
    if (constellation == null)
      return 0;    
    int x = posIniMaison.x+dxZoneReporting;
    Element element = constellation.getIlYAMaison();
    int l = (int)(element.getLargeur()*reducReporting);
    int h = (int)(element.getHauteur()*reducReporting);
    int dyZoneSaisie = (hEtiquette-h)/2; // delta y pour aligner verticalement le cadre de la zone de saisie et le texte
    _pMain.add(element);
    element.setDeplaceable(false);
    element.addActionListener(this);
    element.setIniLocation(x,y+dyZoneSaisie);
    element.setIniDimension(l, h);
    element = constellation.getNbMaison();
    _pMain.add(element);
    element.setDeplaceable(false);
    element.addActionListener(this);
    element.setIniLocation(x+l+lEtiquette/2,y);
    l = 4*lEtiquette;
    h = lEtiquette;
    element.setIniDimension(l, h);
    element = constellation.getEleveALaMaison();
    l = (int)(element.getLargeur()*reducReporting);
    h = (int)(element.getHauteur()*reducReporting);
    x = posIniEcole.x-dxZoneReporting-l;
    _pMain.add(element);
    element.setDeplaceable(false);
    element.addActionListener(this);
    element.setIniLocation(x,y+dyZoneSaisie);
    element.setIniDimension(l, h);
    x = posIniEcole.x+dxZoneReporting;
    element = constellation.getIlYAEcole();
    l = (int)(element.getLargeur()*reducReporting);
    h = (int)(element.getHauteur()*reducReporting);
    _pMain.add(element);
    element.setDeplaceable(false);
    element.addActionListener(this);
    element.setIniLocation(x,y+dyZoneSaisie);
    element.setIniDimension(l, h);
    element = constellation.getNbEcole();
    _pMain.add(element);
    element.setDeplaceable(false);
    element.addActionListener(this);
    element.setIniLocation(x+l+lEtiquette/2,y);
    l = 4*lEtiquette;
    h = lEtiquette;
    element.setIniDimension(l, h);
    element = constellation.getEleveALEcole();
    l = (int)(element.getLargeur()*reducReporting);
    h = (int)(element.getHauteur()*reducReporting);
    x = posIniEcole.x+lZoneSaisie-dxZoneReporting-l;
    _pMain.add(element);
    element.setDeplaceable(false);
    element.addActionListener(this);
    element.setIniLocation(x,y+dyZoneSaisie);
    element.setIniDimension(l, h);
    return hEtiquette;
  }
  
  public void	eventDispatched(AWTEvent e) {
    if (e instanceof MouseEvent) {
      MouseEvent me = (MouseEvent)e;
      Point p = me.getLocationOnScreen();
      _mouseX = p.x;
      _mouseY = p.y;
      super.eventDispatched(e);
      if (isShowing() && _elementSelectionne != null && _rectEcran != null) {
        Point spotMouse = _elementSelectionne.getSpotMouse();
        Point posParent = _elementSelectionne.getParent().getLocationOnScreen();
        _elementSelectionne.setLocation(_mouseX-posParent.x-spotMouse.x, _mouseY-posParent.y-spotMouse.y);        
      }
    } else {
        super.eventDispatched(e);
    }      
  }
  
  public void setElementSelectionne(Element e) {
    if (e == null) { // on relache l'élément
      if (_elementSelectionne != null) { // il y avait bien un élément sélectionné
        if (estCeUnEleve(_elementSelectionne))
          analyseBonneZoneSaisie(_elementSelectionne);
        if (estCeUnNombreDeConstellation(_elementSelectionne))
          analyseBonneZoneNumeriqueConstellation(_elementSelectionne);
        _pMain.setComponentZOrder(_elementSelectionne, _oldZOrder);
      }    
    } else { // on vient de cliquer sur l'élément
        _oldZOrder = _pMain.getComponentZOrder(e);
        _pMain.setComponentZOrder(e, 0);
    }
    _elementSelectionne = e;   
  }

  public Element getElementSelectionne() {
    return _elementSelectionne;
  }
  
  public void analyseBonneZoneSaisie(Element e) {
    Point pIni = e.getIniLocation();
    Element zSCaseMaison = _lesCasesMaison.elementAt(_lesElementsElevesPositionnesMaison.size());
    Element zSCaseEcole = _lesCasesEcole.elementAt(_lesElementsElevesPositionnesEcole.size());
    if (zSCaseMaison.contient(_mouseX, _mouseY)) {
      centreElement(zSCaseMaison, e);
      _lesElementsElevesPositionnesMaison.addElement(e);
      _lesElementsElevesPositionnesEcole.removeElement(e);
    } else if (zSCaseEcole.contient(_mouseX, _mouseY)) {
      centreElement(zSCaseEcole, e);
      _lesElementsElevesPositionnesEcole.addElement(e);
      _lesElementsElevesPositionnesMaison.removeElement(e);
    } else {
      e.setLocation(pIni.x, pIni.y);
    }
    placementsComplets();
  }
  
  public void analyseBonneZoneNumeriqueConstellation(Element e) {
    Point pIni = e.getIniLocation();
    Constellation c = ((TbiRituel)_app).getConstellation(e);
    boolean bNombres = (c == ((TbiRituel)_app).getConstellation(TbiRituel._V_CNombres)); 
    ElementPourConstellation zSMaison = (ElementPourConstellation)c.getNbMaison();
    ElementPourConstellation zSEcole = (ElementPourConstellation)c.getNbEcole();
    zSMaison.removeElement(e); // par précaution
    zSEcole.removeElement(e); // par précaution
    if (zSMaison.contient(_mouseX, _mouseY)) {
      if (zSMaison.getNbCases() > zSMaison.getNbElements()) {
        if (bNombres)
          centreElementEtAjusteHauteur(zSMaison, e);
        else
          centreElement(zSMaison, e);
        zSMaison.addElement(e);
        return;
      }  
    } else if (zSEcole.contient(_mouseX, _mouseY)) {
      if (zSEcole.getNbCases() > zSEcole.getNbElements()) {
        if (bNombres)
          centreElementEtAjusteHauteur(zSEcole, e);
        else
          centreElement(zSEcole, e);
        zSEcole.addElement(e);          
        return;
      } 
    }
    // par défaut, on renvoit à sa position initiale
    e.setLocation(pIni.x, pIni.y);
    if (bNombres) {
      Dimension dimIni = e.getIniDimension();
      e.setDimension(dimIni.width, dimIni.height);
    }
  }
  
  private void centreElement(Element eZs, Element e) {
    Rectangle rEZs = eZs.getBounds();
    Rectangle rE = e.getBounds();
    if (eZs instanceof ElementPourConstellation) {
      int nbElements = ((ElementPourConstellation)eZs).getNbElements();
      e.setLocation(rEZs.x+(nbElements*rE.width), rEZs.y+rEZs.height/2-rE.height/2);
    } else {    
      e.setLocation(rEZs.x+rEZs.width/2-rE.width/2, rEZs.y+rEZs.height/2-rE.height/2);
    }
  }

  private void centreElementEtAjusteHauteur(Element eZs, Element e) {
    Rectangle rEZs = eZs.getBounds();
    Dimension dimIni = e.getIniDimension();
    float ratio = (float)dimIni.width / (float)dimIni.height;
    int h = rEZs.height;
    int l = (int)(h*ratio);
    e.setDimension(l, h);
    Rectangle rE = e.getBounds();
    e.setLocation(rEZs.x+rEZs.width/2-rE.width/2, rEZs.y+rEZs.height/2-rE.height/2);
  }
  
  private void majPositionnementEleves() {
    for(int i = 0; i < _lesElementsElevesPositionnesMaison.size(); i++) 
      centreElement(_lesCasesMaison.elementAt(i), _lesElementsElevesPositionnesMaison.elementAt(i));
    for(int i = 0; i < _lesElementsElevesPositionnesEcole.size(); i++)
      centreElement(_lesCasesEcole.elementAt(i), _lesElementsElevesPositionnesEcole.elementAt(i));
  }
  
  private boolean placementsComplets() {
    majPositionnementEleves();
    if (_lesElementsElevesPositionnesMaison.size()+_lesElementsElevesPositionnesEcole.size() == _lesEleves.size()) {
      return true;
    }
    return false;
  }
  
  public Vector<Element> getElevesALaMaison() {
    return _lesElementsElevesPositionnesMaison;
  }
  
  public Vector<Element> getElevesALEcole() {
    return _lesElementsElevesPositionnesEcole;
  }
  
  public boolean estCeUnEleve(Element e) {
    return _lesElementsEleves.contains(e);
  }
  
  public boolean estCeUnNombreDeConstellation(Element e) {
    return (((TbiRituel)_app).getConstellation(e) != null);  
  }  

}