/*
Copyright Caroline et Serge COUDÉ, (08/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/
package net.sergecoude.TbiRituel;

import java.util.*;
import java.io.*;
import javax.swing.*;
import java.net.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import net.n3.nanoxml.*;
import net.sergecoude.TbiGeneral.*;

public class TbiRituel extends TbiApp {

  private final static long serialVersionUID = 1L;
	
  // Définition des variables propres à l'application
  static public String _V_NomPrononce = "nomprononce";
  private boolean _avecNomPrononce = true;
  static public String _V_JoursCoches = "jourscoches";  
  private boolean _avecJoursCoches = true;
  static public String _V_TTresChaud = "t_treschaud";
  private boolean _avecTTresChaud = true;
  static public String _V_TChaud = "t_chaud";
  private boolean _avecTChaud = true;
  static public String _V_TTempere = "t_tempere";
  private boolean _avecTTempere = true;
  static public String _V_TFroid = "t_froid";
  private boolean _avecTFroid = true;
  static public String _V_TTresFroid = "t_tresfroid";
  private boolean _avecTTresFroid = true;
  static public String _V_COrage = "c_orageux";
  private boolean _avecCOrage = true;
  static public String _V_CCouvert = "c_couvert";
  private boolean _avecCCouvert = true;
  static public String _V_CEnsoleille = "c_ensoleille";
  private boolean _avecCEnsoleille = true;
  static public String _V_CEnsoleilleBlanc = "c_ensoleilleblanc";
  private boolean _avecCEnsoleilleBlanc = true;
  static public String _V_CBrouillard = "c_brouillard";
  private boolean _avecCBrouillard = true;
  static public String _V_PSec = "p_sec";
  private boolean _avecPSec = true;
  static public String _V_PBruine = "p_bruine";
  private boolean _avecPBruine = true;
  static public String _V_PPluie = "p_pluie";
  private boolean _avecPPluie = true;
  static public String _V_PAverse = "p_averse";
  private boolean _avecPAverse = true;
  static public String _V_PGrele = "p_grele";
  private boolean _avecPGrele = true;
  static public String _V_PNeige = "p_neige";
  private boolean _avecPNeige = true;
  static public String _V_VNul = "v_nul";
  private boolean _avecVNul = true;
  static public String _V_VBrise = "v_brise";
  private boolean _avecVBrise = true;
  static public String _V_VFort = "v_fort";
  private boolean _avecVFort = true;
  static public String _V_VTempete = "v_tempete";
  private boolean _avecVTempete = true;
	static public int _V_EDateMeteoPresence = 0;
  static public int _V_EDatePresenceMeteo = 1;
  static public int _V_EMeteoDatePresence = 2;
  static public int _V_EMeteoPresenceDate = 3;
  static public int _V_EPresenceDateMeteo = 4;
  static public int _V_EPresenceMeteoDate = 5;
  static public int _V_EDateMeteo = 6;
  static public int _V_EMeteoDate = 7;
  static public int _V_EDatePresence = 8;
  static public int _V_EPresenceDate = 9;
  static public int _V_EMeteoPresence = 10;
  static public int _V_EPresenceMeteo = 11;
  static public int _V_EDate = 12;
  static public int _V_EMeteo = 13;
  static public int _V_EPresence = 14;
  static public String _V_Enchainement = "enchainement";
  static public String _V_Constellations = "constellations";
  static public int _V_CNombres = 0;
  static public int _V_CDoigts = 1;
  static public int _V_CCarteAPoints = 2;
  static public int _V_CDes = 3;
  static public int _V_CNombresDoigts = 4;
  static public int _V_CNombresCarteAPoints = 5;
  static public int _V_CNombresDes = 6;
  static public int _V_CDoigtsCarteAPoints = 7;
  static public int _V_CDoigtsDes = 8;
  static public int _V_CCarteAPointsDes = 9;
  static public int _V_CNombresDoigtsCarteAPoints = 10;
  static public int _V_CNombresDoigtsDes = 11;
  static public int _V_CNombresCarteAPointsDes = 12;
  static public int _V_CDoigtsCarteAPointsDes = 13;
  static public int _V_CNombresDoigtsCarteAPointsDes = 14;
  
//  private int _constellation = _V_CNombres;
  private Enchainement _enchainementTableaux = null;
  private Vector<Enchainement> _lesEnchainements = null;
  private Constellations _constellations = null;
  private Vector<Constellations> _lesConstellations = null;
  private Constellation _laConstellationNombres, _laConstellationDoigts, _laConstellationCAP, _laConstellationDes;
    
  private PanelTableauMeteo _pTableauMeteo;
  private PanelTableauPresence _pTableauPresence;
  private FenetreFlotante _fenInfo;
  
	public TbiRituel(String fichierLog) {
    super(fichierLog);
    _applicationInfo = new ApplicationInfoRituel();
    setTitle(((ApplicationInfoRituel)_applicationInfo).getNom() + " " + ((ApplicationInfoRituel)_applicationInfo).getVersion());
    _fichierConf = getRepertoireApplication()+"/TbiRituel.conf";
    _nomDuSkin = "skinFrancais";
    /*************************************
     * 0 : TbiGeneralApp.conf    
     * 1 : TbiGeneral.conf
     * 2 : TbiRituelApp.conf     
     * 3 : TbiRituel.conf
     *************************************/
    if (!_configuration.chargeConfiguration("2", "TbiRituelApp.conf", false, false))
      System.exit(-1); 
    if (!_configuration.chargeConfiguration("3", _fichierConf, false, false))
      System.exit(-1); 

    _fenInfo = new FenetreFlotante();
    _fenInfo.setText("Chargement des premières ressources... Patientez !");
    _fenInfo.setTitle(getTitle() + " : Patientez...");
    _fenInfo.setBackground(Color.lightGray);
    try {
      ImageIcon imgIcon = new ImageIcon(getRessource("/" + _applicationInfo.getNom() + ".png"));
      Image icone = imgIcon.getImage();  
      _fenInfo.setIconImage(icone);
    } catch(Exception e) {
      log(e);
    }
    _fenInfo.setVisible(true);    
		_pSelectEcran = new PanelSelectEcran(this);
		_pMain.add(_pSelectEcran,"SelectEcran");
    // enchaînement des panneaux 

		_pTitre = new PanelTitreRituel(this);
		_pMain.add(_pTitre,"Titre");
    getContentPane().setBackground(_cFond);
    initSuivantConfiguration(); // obligatoire !
    // tableau jeu et panneau de conf doivent être chargés après initSuivantConfiguration car chargement des skins au préalable...
		_pTableauJeu = new PanelTableauJeu(this);
		_pMain.add(_pTableauJeu,"TableauJeu");
		_pTableauMeteo = new PanelTableauMeteo(this);
		_pMain.add(_pTableauMeteo,"TableauMeteo");
		_pTableauPresence = new PanelTableauPresence(this);
		_pMain.add(_pTableauPresence,"TableauPresence");
		_pConfig = new PanelConfigRituel(this);
		_pMain.add(_pConfig,"Config");
		// setPanneau doit être appelée après la création du plateau de jeu (setSouris)
		setPanneau("Titre");
		creeLesEnchainements();
		_fenInfo.setVisible(false);
    _timer = new java.util.Timer();
    _timer.schedule(new TimerTask() {
        public void run() {
            setPanneau("SelectEcran");
            stopTimer();
        }
    }, 10000);
		setVisible(true);
	}
	
	private void creeLesEnchainements() {
	  _lesEnchainements = new Vector<Enchainement>();
	  Enchainement ench = new Enchainement(this, "Date du jour, Méteo, Présence", _V_EDateMeteoPresence);
	  ench.ajouteTableau(_pTableauJeu, "Date");
	  ench.ajouteTableau(_pTableauMeteo, "Météo");
	  ench.ajouteTableau(_pTableauPresence, "Présence");
	  _lesEnchainements.addElement(ench);
    ench = new Enchainement(this, "Date du jour, Présence, Méteo", _V_EDatePresenceMeteo);
	  ench.ajouteTableau(_pTableauJeu, "Date");
	  ench.ajouteTableau(_pTableauPresence, "Présence");
	  ench.ajouteTableau(_pTableauMeteo, "Météo");
	  _lesEnchainements.addElement(ench);
    ench = new Enchainement(this, "Méteo, Date du jour, Présence", _V_EMeteoDatePresence);
	  ench.ajouteTableau(_pTableauMeteo, "Météo");
	  ench.ajouteTableau(_pTableauJeu, "Date");
	  ench.ajouteTableau(_pTableauPresence, "Présence");
	  _lesEnchainements.addElement(ench);
    ench = new Enchainement(this, "Méteo, Présence, Date du jour", _V_EMeteoPresenceDate);
	  ench.ajouteTableau(_pTableauMeteo, "Météo");
	  ench.ajouteTableau(_pTableauPresence, "Présence");
	  ench.ajouteTableau(_pTableauJeu, "Date");
	  _lesEnchainements.addElement(ench);
    ench = new Enchainement(this, "Présence, Date du jour, Méteo", _V_EPresenceDateMeteo);
    ench.ajouteTableau(_pTableauPresence, "Présence");
	  ench.ajouteTableau(_pTableauJeu, "Date");
	  ench.ajouteTableau(_pTableauMeteo, "Météo");
	  _lesEnchainements.addElement(ench);
    ench = new Enchainement(this, "Présence, Météo, Date du jour", _V_EPresenceMeteoDate);
    ench.ajouteTableau(_pTableauPresence, "Présence");
	  ench.ajouteTableau(_pTableauMeteo, "Météo");
	  ench.ajouteTableau(_pTableauJeu, "Date");
	  _lesEnchainements.addElement(ench);
    ench = new Enchainement(this, "Date du jour, Méteo", _V_EDateMeteo);
	  ench.ajouteTableau(_pTableauJeu, "Date");
	  ench.ajouteTableau(_pTableauMeteo, "Météo");
	  _lesEnchainements.addElement(ench);
    ench = new Enchainement(this, "Méteo, Date du jour", _V_EMeteoDate);
	  ench.ajouteTableau(_pTableauMeteo, "Météo");
	  ench.ajouteTableau(_pTableauJeu, "Date");
	  _lesEnchainements.addElement(ench);
    ench = new Enchainement(this, "Date du jour, Présence", _V_EDatePresence);
	  ench.ajouteTableau(_pTableauJeu, "Date");
	  ench.ajouteTableau(_pTableauPresence, "Présence");
	  _lesEnchainements.addElement(ench);
    ench = new Enchainement(this, "Présence, Date du jour", _V_EPresenceDate);
	  ench.ajouteTableau(_pTableauPresence, "Présence");
	  ench.ajouteTableau(_pTableauJeu, "Date");
	  _lesEnchainements.addElement(ench);
    ench = new Enchainement(this, "Méteo, Présence", _V_EMeteoPresence);
	  ench.ajouteTableau(_pTableauMeteo, "Météo");
	  ench.ajouteTableau(_pTableauPresence, "Présence");
	  _lesEnchainements.addElement(ench);
    ench = new Enchainement(this, "Présence, Méteo", _V_EPresenceMeteo);
	  ench.ajouteTableau(_pTableauPresence, "Présence");
	  ench.ajouteTableau(_pTableauMeteo, "Météo");
	  _lesEnchainements.addElement(ench);
    ench = new Enchainement(this, "Date du jour", _V_EDate);
	  ench.ajouteTableau(_pTableauJeu, "Date");
	  _lesEnchainements.addElement(ench);
    ench = new Enchainement(this, "Méteo", _V_EMeteo);
	  ench.ajouteTableau(_pTableauMeteo, "Météo");
	  _lesEnchainements.addElement(ench);
    ench = new Enchainement(this, "Présence", _V_EPresence);
	  ench.ajouteTableau(_pTableauPresence, "Présence");
	  _lesEnchainements.addElement(ench);
    setEnchainement(_lesEnchainements.elementAt(Integer.parseInt(getConfiguration(_V_Enchainement))));
  }
  
  private Constellation creeUneConstellation(int type) {
    Constellation laConstellation = null;
    String typeConstellation = "img";
    if (type == TbiRituel._V_CDoigts) {
      typeConstellation = "imgDOIGTS";
      laConstellation = new Constellation("Doigts", type);
    }
    if (type == TbiRituel._V_CCarteAPoints) {
      typeConstellation = "imgCAP";
      laConstellation = new Constellation("Carte à points", type);
    }
    if (type == TbiRituel._V_CDes) {
      typeConstellation = "imgDES";
      laConstellation = new Constellation("Dés", type);
    }
    if (laConstellation == null)
      laConstellation = new Constellation("Nombres", type);   
    try {
      for(int i = 0; i <= 10; i++) { // on double pour la maison et l'école
        laConstellation.addElement(new Element(this, Integer.toString(i), null, null));
        laConstellation.addElement(new Element(this, Integer.toString(i), null, null));        
      }
      if (type == TbiRituel._V_CDoigts || type == TbiRituel._V_CCarteAPoints || type == TbiRituel._V_CDes) {
        laConstellation.addElement(new Element(this, "20", null, null));
        // on double pour la maison et l'école
        laConstellation.addElement(new Element(this, "20", null, null));
        laConstellation.addElement(new Element(this, "30", null, null));
        // on double pour la maison et l'école
        laConstellation.addElement(new Element(this, "30", null, null));
        laConstellation.addElement(new Element(this, "40", null, null));
        // on double pour la maison et l'école
        laConstellation.addElement(new Element(this, "40", null, null));
      } else { // nombres
        for(int i = 11; i <= 40; i++) { 
          laConstellation.addElement(new Element(this, Integer.toString(i), null, null));
          // on double pour la maison et l'école          
          laConstellation.addElement(new Element(this, Integer.toString(i), null, null));
        }
      }
      Element eIlYAMaison = new Element(this, "Il y a", null, null);
      eIlYAMaison.setDeplaceable(false);
      laConstellation.setIlYAMaison(eIlYAMaison);
      Element eIlYAEcole = new Element(this, "Il y a", null, null);
      eIlYAEcole.setDeplaceable(false);
      laConstellation.setIlYAEcole(eIlYAEcole);
      Element eNbMaison = new ElementPourConstellation(this, "nb", null, null, 4);
      eNbMaison.setDeplaceable(false);
      laConstellation.setNbMaison(eNbMaison);
      Element eNbEcole = new ElementPourConstellation(this, "nb", null, null, 4);
      eNbEcole.setDeplaceable(false);
      laConstellation.setNbEcole(eNbEcole);
      Element eEleveALaMaison = new Element(this, "élève à la maison", null, null);
      eEleveALaMaison.setDeplaceable(false);
      laConstellation.setEleveALaMaison(eEleveALaMaison);
      Element eEleveALEcole = new Element(this, "élève à l'école", null, null);
      eEleveALEcole.setDeplaceable(false);
      laConstellation.setEleveALEcole(eEleveALEcole);
    } catch(Exception e) {
      log(e);
    }
    return laConstellation;
  }
  
	private void creeLesConstellations() {
	  _lesConstellations = new Vector<Constellations>();
	  _laConstellationNombres = creeUneConstellation(TbiRituel._V_CNombres);
	  _laConstellationDoigts = creeUneConstellation(TbiRituel._V_CDoigts);
	  _laConstellationCAP = creeUneConstellation(TbiRituel._V_CCarteAPoints);
	  _laConstellationDes = creeUneConstellation(TbiRituel._V_CDes);
	  Constellations c = new Constellations(this, "Nombres", _V_CNombres);
	  c.ajouteConstellation(_laConstellationNombres, true);
	  _lesConstellations.addElement(c);
	  c = new Constellations(this, "Doigts", _V_CDoigts);
	  c.ajouteConstellation(_laConstellationDoigts);
	  _lesConstellations.addElement(c);
	  c = new Constellations(this, "Carte à points", _V_CCarteAPoints);
	  c.ajouteConstellation(_laConstellationCAP);
	  _lesConstellations.addElement(c);
	  c = new Constellations(this, "Dés", _V_CDes);
	  c.ajouteConstellation(_laConstellationDes);
	  _lesConstellations.addElement(c);
	  
	  c = new Constellations(this, "Nombres, Doigts", _V_CNombresDoigts);
	  c.ajouteConstellation(_laConstellationNombres, true);
	  c.ajouteConstellation(_laConstellationDoigts);
	  _lesConstellations.addElement(c);
	  c = new Constellations(this, "Nombres, CAP", _V_CNombresCarteAPoints);
	  c.ajouteConstellation(_laConstellationNombres, true);
	  c.ajouteConstellation(_laConstellationCAP);
	  _lesConstellations.addElement(c);
	  c = new Constellations(this, "Nombres, Dés", _V_CNombresDes);
	  c.ajouteConstellation(_laConstellationNombres, true);
	  c.ajouteConstellation(_laConstellationDes);
	  _lesConstellations.addElement(c);
	  c = new Constellations(this, "Doigts, CAP", _V_CDoigtsCarteAPoints);
	  c.ajouteConstellation(_laConstellationDoigts);
	  c.ajouteConstellation(_laConstellationCAP);
	  _lesConstellations.addElement(c);
	  c = new Constellations(this, "Doigts, Dés", _V_CDoigtsDes);
	  c.ajouteConstellation(_laConstellationDoigts);
	  c.ajouteConstellation(_laConstellationDes);
	  _lesConstellations.addElement(c);
	  c = new Constellations(this, "CAP, Dés", _V_CCarteAPointsDes);
	  c.ajouteConstellation(_laConstellationCAP);
	  c.ajouteConstellation(_laConstellationDes);
	  _lesConstellations.addElement(c);
	  
	  c = new Constellations(this, "Nombres, Doigts, CAP", _V_CNombresDoigtsCarteAPoints);
	  c.ajouteConstellation(_laConstellationNombres, true);
	  c.ajouteConstellation(_laConstellationDoigts);
	  c.ajouteConstellation(_laConstellationCAP);
    _lesConstellations.addElement(c);
	  c = new Constellations(this, "Nombres, Doigts, Dés", _V_CNombresDoigtsDes);
	  c.ajouteConstellation(_laConstellationNombres, true);
	  c.ajouteConstellation(_laConstellationDoigts);
	  c.ajouteConstellation(_laConstellationDes);
	  _lesConstellations.addElement(c);
	  c = new Constellations(this, "Nombres, CAP, Dés", _V_CNombresCarteAPointsDes);
	  c.ajouteConstellation(_laConstellationNombres, true);
	  c.ajouteConstellation(_laConstellationCAP);
	  c.ajouteConstellation(_laConstellationDes);
	  _lesConstellations.addElement(c);
	  c = new Constellations(this, "Doigts, CAP, Dés", _V_CDoigtsCarteAPointsDes);
	  c.ajouteConstellation(_laConstellationDoigts);
	  c.ajouteConstellation(_laConstellationCAP);
	  c.ajouteConstellation(_laConstellationDes);
	  _lesConstellations.addElement(c);

	  c = new Constellations(this, "Nombres, Doigts, CAP, Dés", _V_CNombresDoigtsCarteAPointsDes);
	  c.ajouteConstellation(_laConstellationNombres, true);
	  c.ajouteConstellation(_laConstellationDoigts);
	  c.ajouteConstellation(_laConstellationCAP);
	  c.ajouteConstellation(_laConstellationDes);
	  _lesConstellations.addElement(c);
	  
    setConstellations(_lesConstellations.elementAt(Integer.parseInt(getConfiguration(_V_Constellations))));
  }
  
  public Constellation getConstellation(int type) {
    if (type == TbiRituel._V_CNombres)
      return _laConstellationNombres;
    if (type == TbiRituel._V_CDoigts)
      return _laConstellationDoigts;
    if (type == TbiRituel._V_CCarteAPoints)
      return _laConstellationCAP;
    if (type == TbiRituel._V_CDes)
      return _laConstellationDes;
    return null;
  }
  
  public Constellation getConstellation(Element e) {
    if (_laConstellationNombres.contains(e))
      return _laConstellationNombres;
    if (_laConstellationDoigts.contains(e))
      return _laConstellationDoigts;
    if (_laConstellationCAP.contains(e))
      return _laConstellationCAP;
    if (_laConstellationDes.contains(e))
      return _laConstellationDes;
    return null;
  }  
  
  public Vector<Constellations> getLesConstellations() {
    return _lesConstellations;
  }
  
  public float setSkinDesConstellations(BarreProgression bProgression, float nbElements, float nbElementsTotal) {
    try {
      nbElements = _laConstellationNombres.setSkin(getSkin(), bProgression, nbElements, nbElementsTotal);
      nbElements = _laConstellationDoigts.setSkin(getSkin(), bProgression, nbElements, nbElementsTotal);
      nbElements = _laConstellationCAP.setSkin(getSkin(), bProgression, nbElements, nbElementsTotal);
      nbElements = _laConstellationDes.setSkin(getSkin(), bProgression, nbElements, nbElementsTotal);
    } catch(Exception e) {
      log(e);
    }
    return nbElements;    
  }
	
	@Override
  public String getRepertoireApplication() {
    return "TbiRituel";
  } 
	
	@Override
  protected void quitter() {
    int rep = JOptionPane.showConfirmDialog(_pFrame, "Souhaitez-vous enregistrer les informations du jour ?", "Quitter", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
    if (rep == JOptionPane.NO_OPTION || enregistrerLesEvaluations()) 
      System.exit(0);
  }
  
  @Override
  public void initSuivantConfiguration() {
    super.initSuivantConfiguration();
    setNbExercices(Integer.parseInt(getConfiguration(_V_NbExercices))); // obligatoire 
    if (getConfiguration(_V_NomPrononce).toLowerCase().equals("oui"))
      setAvecNomPrononce(true);
    else 
      setAvecNomPrononce(false);
    if (getConfiguration(_V_JoursCoches).toLowerCase().equals("oui"))
      setAvecJoursCoches(true);
    else 
      setAvecJoursCoches(false);
    setAvecElementMeteo(_V_TTresChaud, getConfiguration(_V_TTresChaud).toLowerCase().equals("oui"));
    setAvecElementMeteo(_V_TChaud, getConfiguration(_V_TChaud).toLowerCase().equals("oui"));
    setAvecElementMeteo(_V_TTempere, getConfiguration(_V_TTempere).toLowerCase().equals("oui"));
    setAvecElementMeteo(_V_TFroid, getConfiguration(_V_TFroid).toLowerCase().equals("oui"));
    setAvecElementMeteo(_V_TTresFroid, getConfiguration(_V_TTresFroid).toLowerCase().equals("oui"));
    setAvecElementMeteo(_V_PSec, getConfiguration(_V_PSec).toLowerCase().equals("oui"));
    setAvecElementMeteo(_V_PPluie, getConfiguration(_V_PPluie).toLowerCase().equals("oui"));
    setAvecElementMeteo(_V_PAverse, getConfiguration(_V_PAverse).toLowerCase().equals("oui"));
    setAvecElementMeteo(_V_PGrele, getConfiguration(_V_PGrele).toLowerCase().equals("oui"));
    setAvecElementMeteo(_V_PNeige, getConfiguration(_V_PNeige).toLowerCase().equals("oui"));
    setAvecElementMeteo(_V_COrage, getConfiguration(_V_COrage).toLowerCase().equals("oui"));
    setAvecElementMeteo(_V_CCouvert, getConfiguration(_V_CCouvert).toLowerCase().equals("oui"));
    setAvecElementMeteo(_V_CEnsoleilleBlanc, getConfiguration(_V_CEnsoleilleBlanc).toLowerCase().equals("oui"));
    setAvecElementMeteo(_V_CBrouillard, getConfiguration(_V_CBrouillard).toLowerCase().equals("oui"));
    setAvecElementMeteo(_V_CEnsoleille, getConfiguration(_V_CEnsoleille).toLowerCase().equals("oui"));
    setAvecElementMeteo(_V_VNul, getConfiguration(_V_VNul).toLowerCase().equals("oui"));
    setAvecElementMeteo(_V_VFort, getConfiguration(_V_VFort).toLowerCase().equals("oui"));
    setAvecElementMeteo(_V_VTempete, getConfiguration(_V_VTempete).toLowerCase().equals("oui"));
    setUtilisationDesClasses(true); // on force l'utilisation des classes pour l'enregistrement des données (évaluations)
		creeLesConstellations(); // à appeler avant setConstellations une fois le skin chargé
    setConstellations(_lesConstellations.elementAt(Integer.parseInt(getConfiguration(_V_Constellations))));
     
  }
	
	@Override
	public void setPanneau(String p) {
	  if (!p.equals("TableauJeu") && 
        !p.equals("TableauMeteo") &&
        !p.equals("TableauPresence")) {
      setCursor(Cursor.getDefaultCursor());
      _pTableauJeu.setSouris(false);
      _pTableauMeteo.setSouris(false);
      _pTableauPresence.setSouris(false);
    } else {
      if (_evaluationCourante == null)
        demarreNouvelleEvaluation();
    }
    if (p.equals("TableauJeu"))
      _pTableauJeu.setSouris(true);
    if (p.equals("TableauMeteo"))
      _pTableauMeteo.setSouris(false);
    if (p.equals("TableauPresence"))
      _pTableauPresence.setSouris(false);
    super.setPanneau(p);
	}
	
  public void setAvecNomPrononce(boolean oui) {
    _avecNomPrononce = oui;
  }

  public boolean getAvecNomPrononce() {
    return _avecNomPrononce;
  }

  public void setAvecJoursCoches(boolean oui) {
    _avecJoursCoches = oui;
  }
  
  public void setAvecElementMeteo(String vElement, boolean oui) {
    if (vElement.equals(_V_TTresChaud))
      _avecTTresChaud = oui;
    if (vElement.equals(_V_TChaud))
      _avecTChaud = oui;
    if (vElement.equals(_V_TTempere))
      _avecTTempere = oui;
    if (vElement.equals(_V_TFroid))
      _avecTFroid = oui;
    if (vElement.equals(_V_TTresFroid))
      _avecTTresFroid = oui;
    if (vElement.equals(_V_PSec))
      _avecPSec = oui;
    if (vElement.equals(_V_PPluie))
      _avecPPluie = oui;
    if (vElement.equals(_V_PAverse))
      _avecPAverse = oui;
    if (vElement.equals(_V_PGrele))
      _avecPGrele = oui;
    if (vElement.equals(_V_PNeige))
      _avecPNeige = oui;
    if (vElement.equals(_V_COrage))
      _avecCOrage = oui;
    if (vElement.equals(_V_CCouvert))
      _avecCCouvert = oui;
    if (vElement.equals(_V_CEnsoleilleBlanc))
      _avecCEnsoleilleBlanc = oui;
    if (vElement.equals(_V_CBrouillard))
      _avecCBrouillard = oui;
    if (vElement.equals(_V_CEnsoleille))
      _avecCEnsoleille = oui;
    if (vElement.equals(_V_VNul))
      _avecVNul = oui;
    if (vElement.equals(_V_VFort))
      _avecVFort = oui;
    if (vElement.equals(_V_VTempete))
      _avecVTempete = oui;
  }

  public boolean getAvecElementMeteo(String vElement) {
    if (vElement.equals(_V_TTresChaud))
      return _avecTTresChaud;
    if (vElement.equals(_V_TChaud))
      return _avecTChaud;
    if (vElement.equals(_V_TTempere))
      return _avecTTempere;
    if (vElement.equals(_V_TFroid))
      return _avecTFroid;
    if (vElement.equals(_V_TTresFroid))
      return _avecTTresFroid;
    if (vElement.equals(_V_PSec))
      return _avecPSec;
    if (vElement.equals(_V_PPluie))
      return _avecPPluie;
    if (vElement.equals(_V_PAverse))
      return _avecPAverse;
    if (vElement.equals(_V_PGrele))
      return _avecPGrele;
    if (vElement.equals(_V_PNeige))
      return _avecPNeige;
    if (vElement.equals(_V_COrage))
      return _avecCOrage;
    if (vElement.equals(_V_CCouvert))
      return _avecCCouvert;
    if (vElement.equals(_V_CEnsoleilleBlanc))
      return _avecCEnsoleilleBlanc;
    if (vElement.equals(_V_CBrouillard))
      return _avecCBrouillard;
    if (vElement.equals(_V_CEnsoleille))
      return _avecCEnsoleille;
    if (vElement.equals(_V_VNul))
      return _avecVNul;
    if (vElement.equals(_V_VFort))
      return _avecVFort;
    if (vElement.equals(_V_VTempete))
      return _avecVTempete;
    return true;
  }
  
  public void majEnchainementSuivantSkin() {
    _enchainementTableaux.setIntitule(_pTableauJeu, getSkin().getTraduction("OngletDate"));
    _enchainementTableaux.setIntitule(_pTableauMeteo, getSkin().getTraduction("OngletMeteo"));
    _enchainementTableaux.setIntitule(_pTableauPresence, getSkin().getTraduction("OngletPresence"));
  }
  
  public Vector<Enchainement> getLesEnchainements() {
    return _lesEnchainements;
  }
  
  public Enchainement getEnchainement() {
    return _enchainementTableaux;
  }

  public void setEnchainement(Enchainement enchainement) {
    _enchainementTableaux = enchainement;
    clearPanneauApresSelectClasse();
    clearPanneauApresSelectEleve();
    enchainement.reset();
    PanelJeu pj = enchainement.suivant();
    while (pj != null) {
      if (pj == _pTableauJeu) {
        addPanneauApresSelectClasse("TableauJeu");
        addPanneauApresSelectEleve("TableauJeu");
      }
      if (pj == _pTableauMeteo) {
        addPanneauApresSelectClasse("TableauMeteo");
        addPanneauApresSelectEleve("TableauMeteo");
      }
      if (pj == _pTableauPresence) {
        addPanneauApresSelectClasse("TableauPresence"); // à définir obligatoirement
        addPanneauApresSelectEleve("TableauPresence"); // à définir obligatoirement
      }
      pj = enchainement.suivant(); 
    }
    enchainement.reset();
    majEnchainementSuivantSkin();
    ((PanelTableauJeu)_pTableauJeu).setEnchainement(enchainement);
    _pTableauMeteo.setEnchainement(enchainement);
    _pTableauPresence.setEnchainement(enchainement);
  }

  public Constellations getConstellations() {
    return _constellations;
  }

  public void setConstellations(Constellations constellations) {
    _constellations = constellations;
  }
  
  public boolean isElementMeteoSelected(String elem) {
    return ((PanelConfigRituel)_pConfig).isSelected(elem);
  }

  public boolean getAvecJoursCoches() {
    return _avecJoursCoches;
  }
  
  @Override
  public boolean sauveConfiguration() {
    /*************************************
     * 0 : TbiGeneralApp.conf    
     * 1 : TbiGeneral.conf
     * 2 : TbiRituelApp.conf     
     * 3 : TbiRituel.conf
     *************************************/
    setConfiguration("3", _V_NomPrononce, _avecNomPrononce ? "oui" : "non");
    setConfiguration("3", _V_JoursCoches, _avecJoursCoches ? "oui" : "non");
    setConfiguration("3", _V_TailleSouris, Integer.toString(_tailleCurseur));
    setConfiguration("3", _V_UtilisationTBI, _avecTbi ? "oui" : "non");
    setConfiguration("3", _V_LargeurTBI, Integer.toString(_largeurTbi));    
    setConfiguration("3", _V_HauteurTBI, Integer.toString(_hauteurTbi));
    setConfiguration("3", _V_CoordXTBI, Integer.toString(_xTbi));    
    setConfiguration("3", _V_CoordYTBI, Integer.toString(_yTbi));
    //setConfiguration("3", _V_UtilisationDesClasses, _utilisationDesClasses ? "oui" : "non");
    setConfiguration("3", _V_UtilisationDesClasses, "oui");
    setConfiguration("3", _V_NomDuSkin, getNomDuSkin());
    setConfiguration("3", _V_TTresChaud, getAvecElementMeteo(_V_TTresChaud) ? "oui" : "non");
    setConfiguration("3", _V_TChaud, getAvecElementMeteo(_V_TChaud) ? "oui" : "non");
    setConfiguration("3", _V_TTempere, getAvecElementMeteo(_V_TTempere) ? "oui" : "non");
    setConfiguration("3", _V_TFroid, getAvecElementMeteo(_V_TFroid) ? "oui" : "non");
    setConfiguration("3", _V_TTresFroid, getAvecElementMeteo(_V_TTresFroid) ? "oui" : "non");
    setConfiguration("3", _V_PSec, getAvecElementMeteo(_V_PSec) ? "oui" : "non");
    setConfiguration("3", _V_PPluie, getAvecElementMeteo(_V_PPluie) ? "oui" : "non");
    setConfiguration("3", _V_PAverse, getAvecElementMeteo(_V_PAverse) ? "oui" : "non");
    setConfiguration("3", _V_PGrele, getAvecElementMeteo(_V_PGrele) ? "oui" : "non");
    setConfiguration("3", _V_PNeige, getAvecElementMeteo(_V_PNeige) ? "oui" : "non");
    setConfiguration("3", _V_COrage, getAvecElementMeteo(_V_COrage) ? "oui" : "non");
    setConfiguration("3", _V_CCouvert, getAvecElementMeteo(_V_CCouvert) ? "oui" : "non");
    setConfiguration("3", _V_CEnsoleilleBlanc, getAvecElementMeteo(_V_CEnsoleilleBlanc) ? "oui" : "non");
    setConfiguration("3", _V_CBrouillard, getAvecElementMeteo(_V_CBrouillard) ? "oui" : "non");
    setConfiguration("3", _V_CEnsoleille, getAvecElementMeteo(_V_CEnsoleille) ? "oui" : "non");
    setConfiguration("3", _V_VNul, getAvecElementMeteo(_V_VNul) ? "oui" : "non");
    setConfiguration("3", _V_VFort, getAvecElementMeteo(_V_VFort) ? "oui" : "non");
    setConfiguration("3", _V_VTempete, getAvecElementMeteo(_V_VTempete) ? "oui" : "non");
    setConfiguration("3", _V_Enchainement, Integer.toString(getEnchainement().getId()));
    setConfiguration("3", _V_Constellations, Integer.toString(getConstellations().getId()));        
    return sauveConfiguration("3"); // fichier TbiRituel.conf
  }
  
  public void tableauSuivant(PanelJeu pjPrecedent) {
      _enchainementTableaux.reset();
      PanelJeu pj = _enchainementTableaux.suivant();
      while (pj != pjPrecedent) 
        pj = _enchainementTableaux.suivant();
      pj = _enchainementTableaux.suivant();
      if (pj == _pTableauJeu) 
        setPanneau("TableauJeu");
      if (pj == _pTableauMeteo) 
        setPanneau("TableauMeteo");
      if (pj == _pTableauPresence) 
        setPanneau("TableauPresence");
  }
  
  public Enchainement getEnchainementParId(int id) {
    for(int e = 0; e < _lesEnchainements.size(); e++) 
      if (_lesEnchainements.elementAt(e).getId() == id)
        return _lesEnchainements.elementAt(e);
    return null; 
  }
  
  @Override
  public boolean demarreNouvelleEvaluation() {
    Evaluation ev = setEvaluation(getNewEvaluation());
    initEvaluation(ev);
    ev.start();
    return true;
  }  
  
  public Evaluation getNewEvaluation() {
    EvaluationRituel eval = new EvaluationRituel(this);
    return eval;
  }

  @Override
  public String genereCleEvaluation() {
    return getApplicationInfo().getNom();
  }

  @Override
  public String genereNomEvaluation() {
    return getApplicationInfo().getNom();
  }

  public Evaluation getNewEvaluation(IXMLElement xml) throws Exception {
    EvaluationRituel eval = new EvaluationRituel(this);
    eval.chargeEvaluation(xml);
    return eval;
  }
  
  public Evaluation getNewEvaluation(String fichier) throws Exception {
    return new EvaluationRituel(this, fichier);
  }  
  
  @Override
  public boolean enregistrerLesEvaluations() {
    if (_evaluationCourante != null) {
      _evaluationCourante.stop();
      if (_pTableauMeteo.getTemperature() != null)
        ((EvaluationRituel)_evaluationCourante).setTemperature(_pTableauMeteo.getTemperature().getId());
      if (_pTableauMeteo.getCiel() != null)
        ((EvaluationRituel)_evaluationCourante).setCiel(_pTableauMeteo.getCiel().getId());
      if (_pTableauMeteo.getPrecipitation() != null)
        ((EvaluationRituel)_evaluationCourante).setPrecipitation(_pTableauMeteo.getPrecipitation().getId());
      if (_pTableauMeteo.getVent() != null)
        ((EvaluationRituel)_evaluationCourante).setVent(_pTableauMeteo.getVent().getId());
      Vector<Element> lesElevesMaison = _pTableauPresence.getElevesALaMaison();
      if (lesElevesMaison != null) {
        String maison = "";
        for(int i = 0; i < lesElevesMaison.size(); i++) 
          maison += lesElevesMaison.elementAt(i).getId() + (i+1 < lesElevesMaison.size() ? "," : "");
        ((EvaluationRituel)_evaluationCourante).setElevesMaison(maison);        
      }
      Vector<Element> lesElevesEcole = _pTableauPresence.getElevesALEcole();
      if (lesElevesEcole != null) {
        String ecole = "";
        for(int i = 0; i < lesElevesEcole.size(); i++) 
          ecole += lesElevesEcole.elementAt(i).getId() + (i+1 < lesElevesEcole.size() ? "," : "");
        ((EvaluationRituel)_evaluationCourante).setElevesEcole(ecole);        
      }
      try {
        _evaluationCourante.enregistrer(getCheminDesEvaluations());
      } catch(Exception e) {
        e.printStackTrace();
        message("Erreur lors de l'enregistrement de l'évaluation : " + e.toString(), MESSAGE_ERREUR);
        return false; 
      }
      JOptionPane.showMessageDialog(_pFrame, "Enregistrement des informations ok !", "Quitter", JOptionPane.INFORMATION_MESSAGE);
    } else {
      JOptionPane.showMessageDialog(_pFrame, "Pas de données à enregistrer... Donc pas d'enregistrement !", "Quitter", JOptionPane.WARNING_MESSAGE);
    }
    return true;
  }  
  
	public static void main(String[] args) {
 	  try {
      new TbiRituel("TbiRituel.log");
	  } catch (Exception e) {
      Log.logStatic(e);
    }
	}
}
