/*
Copyright Caroline et Serge COUDÉ, (04/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/

package net.sergecoude.pluginRituel;

import javax.swing.*;
import java.net.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.util.Map.*;
import javax.swing.event.*;
import java.awt.image.*;
import java.text.*;
import net.sergecoude.TbiGeneral.*;
import net.sergecoude.TbiAdmin.*;
import net.sergecoude.TbiRituel.*;
import com.itextpdf.text.*;
import com.itextpdf.text.pdf.*;
import org.jfree.chart.*;
import org.jfree.chart.plot.*;
import org.jfree.chart.renderer.category.*;
import org.jfree.data.*;
import org.jfree.data.category.*;
import org.jfree.chart.labels.*;

public class pluginEvaluations extends PluginEvaluations {

  private DefaultListModel _lesLangues = null;
  private DefaultListModel _lesRituels = null;
  private Vector<ItemLangue> _lesLanguesSelectionnees = new Vector<ItemLangue>();
  private Vector<ItemRituel> _lesRituelsSelectionnes = new Vector<ItemRituel>();
  private JListJButton _listeLangues = null;
  private JListJButton _listeRituels = null;
  private JScrollPane _scLangues = null;
  private JScrollPane _scRituels = null;
  private JCheckBox _cbLangues = null;
  private JCheckBox _cbRituels = null;
  private HashMap<ItemLangue,HashMap<ItemRituel,Vector<ItemEvaluation>>> _lesItems = null;
  
  public pluginEvaluations() {
    super();
    _nomApplication = "TbiRituel 2.0";
    try {
    _listeLangues = new JListJButton();
    _listeLangues.setFont(_police);
    _listeLangues.addListSelectionListener(this);
    _listeLangues.addMouseListener(new JListMouseListener(_listeLangues));
    _listeLangues.addMouseListener(this); 
    _listeLangues.setCellRenderer(new ItemObjetCellRenderer());       
    _scLangues = new JScrollPane(_listeLangues);
    _cbLangues = new JCheckBox("Toutes");
    _cbLangues.setOpaque(false);
    _cbLangues.setFont(_policeLibelle);
    _cbLangues.addItemListener(this);

    _listeRituels = new JListJButton();
    _listeRituels.setFont(_police);
    _listeRituels.addListSelectionListener(this);
    _listeRituels.addMouseListener(new JListMouseListener(_listeRituels));
    _listeRituels.addMouseListener(this);
    _listeRituels.setCellRenderer(new ItemObjetCellRenderer());       
    _scRituels = new JScrollPane(_listeRituels);
    _cbRituels = new JCheckBox("Tous");
    _cbRituels.setOpaque(false);
    _cbRituels.setFont(_policeLibelle);
    _cbRituels.addItemListener(this);
    
    setLayout(new BorderLayout(30,0));
    JPanel pMain = new JPanel(new GridLayout(1,3,30,30));
    pMain.setOpaque(false);
    Box pLangues = Box.createVerticalBox();
    Box pLanguesHaut = Box.createHorizontalBox();
    JLabel lLangues = new JLabel("Langues...", JLabel.LEFT);
    lLangues.setFont(_policeLibelle);
    pLanguesHaut.add(Box.createHorizontalGlue());
    pLanguesHaut.add(lLangues);
    pLanguesHaut.add(Box.createHorizontalGlue());
    pLanguesHaut.add(_cbLangues);
    pLanguesHaut.setAlignmentX(Component.CENTER_ALIGNMENT);
    pLangues.add(pLanguesHaut);
    _scLangues.setAlignmentX(Component.CENTER_ALIGNMENT);
    pLangues.add(_scLangues);
    pMain.add(pLangues);
    Box pRituels = Box.createVerticalBox();
    Box pRituelsHaut = Box.createHorizontalBox();
    JLabel lRituels = new JLabel("Rituels...", JLabel.LEFT);
    lRituels.setFont(_policeLibelle);
    pRituelsHaut.add(Box.createHorizontalGlue());
    pRituelsHaut.add(lRituels);
    pRituelsHaut.add(Box.createHorizontalGlue());
    pRituelsHaut.add(_cbRituels);
    pRituelsHaut.setAlignmentX(Component.CENTER_ALIGNMENT);
    pRituels.add(pRituelsHaut);
    _scRituels.setAlignmentX(Component.CENTER_ALIGNMENT);
    pRituels.add(_scRituels);
    pMain.add(pRituels);
    Box pEvaluations = Box.createVerticalBox();
    Box pEvaluationsHaut = Box.createHorizontalBox();
    JLabel lEvaluations = new JLabel("Enregistrements...", JLabel.LEFT);
    lEvaluations.setFont(_policeLibelle);
    pEvaluationsHaut.add(Box.createHorizontalGlue());
    pEvaluationsHaut.add(lEvaluations);
    pEvaluationsHaut.add(Box.createHorizontalGlue());
    pEvaluationsHaut.add(_cbEvaluations);
    pEvaluationsHaut.setAlignmentX(Component.CENTER_ALIGNMENT);
    pEvaluations.add(pEvaluationsHaut);
    _scEvaluations.setAlignmentX(Component.CENTER_ALIGNMENT);
    pEvaluations.add(_scEvaluations);
    pMain.add(pEvaluations);
    add(pMain, BorderLayout.CENTER);
    } catch(Exception e) {
      e.printStackTrace();
    }
    _lesItems = new HashMap<ItemLangue,HashMap<ItemRituel,Vector<ItemEvaluation>>>();
  }
  
  @Override
  public String getNomApplication() {
    return "TbiRituel";
  }

  @Override
  public String getVersionApplication() {
    return "2.0";
  }
  
  @Override
  public void init(TbiApp app, Application application) {
    super.init(app, application);
    _app = (TbiAdmin)app;
    chargeLesLangues(); // initialise la hashmap _lesItems puis charge les évaluations
  }
  
  @Override
  public void reset() {
    super.reset();
    _listeLangues.clearSelection();
    _listeRituels.setModel(new DefaultListModel());
    _listeEvaluations.setModel(new DefaultListModel());
    majPlugin(); 
  }

  @Override   
  protected JComponent creePanneauTypesGraphiques() {
    JComponent pTypesGraphiques = super.creePanneauTypesGraphiques();
    add(pTypesGraphiques, BorderLayout.EAST);
    return pTypesGraphiques;
  }

  private void chargeLesLangues() {
    _app.message("Chargement des langues...", _app.MESSAGE_INFORMATION, 0);
    if (_lesLangues == null) {
      _lesLangues = new DefaultListModel();
      _listeLangues.setModel(_lesLangues);
    }
    _lesLangues.clear();
    _listeLangues.setEnabled(false);
    File[] fichiers = null;
    File repertoireLangues = new File("TbiRituel");
    if (repertoireLangues.exists()) {
      try {
        fichiers = repertoireLangues.listFiles();
        if (fichiers != null) 
          for(int f = 0; f < fichiers.length; f++) 
            if (fichiers[f].isFile() && fichiers[f].getName().startsWith("skin") && fichiers[f].getName().toLowerCase().endsWith(".jar")) {
              String nom = fichiers[f].getName().substring(4,fichiers[f].getName().length()-4);
              ItemLangue item = new ItemLangue(nom);
              item.addItemListener(this);
              _lesLangues.addElement(item);
              chargeSkin(fichiers[f].getName());
              HashMap<ItemRituel,Vector<ItemEvaluation>> lesItemsRituels = new HashMap<ItemRituel,Vector<ItemEvaluation>>();
              Vector<ItemRituel> vItemsRituels = creeLesItemsRituels();
              for(int i = 0; i < vItemsRituels.size(); i++) 
                lesItemsRituels.put(vItemsRituels.elementAt(i), new Vector<ItemEvaluation>());
              _lesItems.put(item, lesItemsRituels);              
          }
      } catch (Exception e) {
        _app.message(e, _app.MESSAGE_AVERTISSEMENT);      
      }
    } 
    _listeLangues.setEnabled(true);
    if (_lesLangues.getSize() > 0)
      _app.message("Chargement des langues : " + _lesLangues.getSize() + " trouvée" + (_lesLangues.getSize() > 1 ? "s" : "") + " !", _app.MESSAGE_INFORMATION, 3000);
    else 
      _app.message("Chargement des langues : aucune langue trouvée...", _app.MESSAGE_AVERTISSEMENT, 3000);
    chargeLesEvaluations();
  }

  private Vector<ItemRituel> creeLesItemsRituels() {
    Vector<ItemRituel> lesItemsRituels = new Vector<ItemRituel>();
    ItemRituel item = new ItemRituel("Météorologie");
    item.addItemListener(this);
    lesItemsRituels.addElement(item);
    item = new ItemRituel("Absents/Présents");
    item.addItemListener(this);
    lesItemsRituels.addElement(item);
    return lesItemsRituels;
  }
  
  private Vector<ItemEvaluation> getItemsEvaluationsDeLangueEtDeRituel(String nLangue, String nRituel) {
    HashMap<ItemRituel,Vector<ItemEvaluation>> lesRituels = getItemsRituelsDeLangue(nLangue);
    if (lesRituels != null) 
      for(Entry<ItemRituel,Vector<ItemEvaluation>> entreeRituel : lesRituels.entrySet()) {
        ItemRituel itemRituel = entreeRituel.getKey();
        String rituel = itemRituel.getRituel();
        if (rituel.equals(nRituel))
          return entreeRituel.getValue();
      }     
    return null;
  } 
  
  private HashMap<ItemRituel,Vector<ItemEvaluation>> getItemsRituelsDeLangue(String nLangue) {
    for(Entry<ItemLangue, HashMap<ItemRituel,Vector<ItemEvaluation>>> entreeItem : _lesItems.entrySet()) {
      ItemLangue itemLangue = entreeItem.getKey();
      if (itemLangue.getLangue().equals(nLangue)) {
        return entreeItem.getValue();
      }  
    }
    return null;
  }
  
  private Vector<ItemEvaluation> getItemsEvaluationsDuRituel(ItemRituel item) {
    for(Entry<ItemLangue, HashMap<ItemRituel,Vector<ItemEvaluation>>> entreeItem : _lesItems.entrySet()) {
      ItemLangue itemLangue = entreeItem.getKey();
      HashMap<ItemRituel,Vector<ItemEvaluation>> lesRituels = entreeItem.getValue();
      if (lesRituels != null)
        for(Entry<ItemRituel,Vector<ItemEvaluation>> entreeRituel : lesRituels.entrySet()) {
          ItemRituel iRituel = entreeRituel.getKey();
          if (iRituel == item)
            return entreeRituel.getValue();
        }
    }
    return null;
  }

  @Override
  public void videLesEvaluations() {
    for(Entry<ItemLangue, HashMap<ItemRituel,Vector<ItemEvaluation>>> entreeItem : _lesItems.entrySet()) 
      for(Entry<ItemRituel,Vector<ItemEvaluation>> entreeRituel : entreeItem.getValue().entrySet()) 
        entreeRituel.getValue().clear(); // les itemsEvaluations
  }
  
  @Override
  public void chargeLesEvaluations() {
    // appelée par init ou par reset
    // charge la totalité des évaluations de TbiRituel pour la classe sélectionée et les réparti en fonction du theme et du niveau de difficulté
    _app.message("Chargement des évaluations pour le plugin " + getNomApplication() + "...", _app.MESSAGE_INFORMATION, 3000);
    videLesEvaluations();    
    File repertoire = new File(((TbiAdmin)_app).getCheminDesEvaluations() + File.separator + _application.getRepertoire().getName());
    int cptErreur = 0;
    int cptEval = 0;
    if (repertoire.exists()) {
      File[] fichiers = repertoire.listFiles();
      if (fichiers != null) {
        for(int f = 0; f < fichiers.length; f++) {
          if (fichiers[f].isFile() && fichiers[f].getName().endsWith("-eval.xml")) {
            try {
              EvaluationRituel eval = new EvaluationRituel(_app, fichiers[f].getAbsolutePath());
              String nLangue  = eval.getLangue();
              boolean bMeteo = eval.contientMeteo();
              boolean bPresence = eval.contientPresence();
              if (eval.getClasse() != null && _laClasseSelectionnee != null && eval.getClasse().getId().equals(_laClasseSelectionnee.getId())) {
                ItemEvaluation itemEval = new ItemEvaluation(eval);
                itemEval.addItemListener(this);
                if (bMeteo) {              
                  Vector<ItemEvaluation> lesItemsEvaluationsMeteo = getItemsEvaluationsDeLangueEtDeRituel(nLangue, "Météorologie");
                  lesItemsEvaluationsMeteo.addElement(itemEval);
                }
                if (bPresence) {
                  Vector<ItemEvaluation> lesItemsEvaluationsPresence = getItemsEvaluationsDeLangueEtDeRituel(nLangue, "Absents/Présents");
                  lesItemsEvaluationsPresence.addElement(itemEval);
                }
                if (bMeteo || bPresence)
                  cptEval++;
              }
            } catch(Exception e) {
              _app.message(e.toString(), _app.MESSAGE_AVERTISSEMENT, 3000);
              e.printStackTrace();
              cptErreur++;
            }
          }
        }
      }
    }
    // tri des évaluations de la plus récente à la plus ancienne pour chaque langue et chaque rituel
    // coche les items "langue", "rituel" et "évaluation" si présents dans les évaluations
    ArrayList<ParametreDeTri> lesParametres = new ArrayList<ParametreDeTri>();
    lesParametres.add(new ParametreDeTri(Evaluation.DATE_DESC, "Date récente->ancienne"));
    for(Entry<ItemLangue, HashMap<ItemRituel,Vector<ItemEvaluation>>> entreeLangue : _lesItems.entrySet()) {
      ItemLangue itemLangue = entreeLangue.getKey();
      HashMap<ItemRituel,Vector<ItemEvaluation>> lesRituels = entreeLangue.getValue();
      boolean languePresente = false;
      for(Entry<ItemRituel,Vector<ItemEvaluation>> entreeRituel : lesRituels.entrySet()) {
        ItemRituel itemRituel = entreeRituel.getKey();
        Vector<ItemEvaluation> lesItemsEvaluations = entreeRituel.getValue();
        boolean rituelPresent = false;
        if (lesItemsEvaluations.size() > 0) {
          for(int e = 0; e < lesItemsEvaluations.size(); e++) 
            lesItemsEvaluations.elementAt(e).setPresentDansEvaluation(true);
          rituelPresent = true;
          languePresente = true;
        }
        itemRituel.setPresentDansEvaluation(rituelPresent);
      }
      itemLangue.setPresentDansEvaluation(languePresente);
    } 
    if (cptEval > 0) {
      _app.message("Chargement des évaluations du plugin " + getNomApplication() + " et la classe " + _laClasseSelectionnee.getNom() + " : " + cptEval + " trouvée" + (cptEval > 1 ? "s" : "") + " !" + (cptErreur > 0 ? " (+ " + cptErreur + " erronnée" + (cptErreur > 1 ? "s" : "") + ")" : ""), (cptErreur > 0 ? _app.MESSAGE_AVERTISSEMENT : _app.MESSAGE_INFORMATION), 3000);
    } else 
      _app.message("Chargement des évaluations du plugin " + getNomApplication() + " et la classe " + _laClasseSelectionnee.getNom() + " : aucune évaluation trouvée..." + (cptErreur > 0 ? " (+ " + cptErreur + " erronnée" + (cptErreur > 1 ? "s" : "") + ")" : ""), (cptErreur > 0 ? _app.MESSAGE_AVERTISSEMENT : _app.MESSAGE_INFORMATION), 3000);
    ((TbiAdmin)_app).majPlugin(this);
  }
  
  @Override
  public void valueChanged(ListSelectionEvent evt) {
    if (!evt.getValueIsAdjusting()) {
      if (evt.getSource() == _listeLangues) {
        ItemLangue iLangue = (ItemLangue)_listeLangues.getSelectedValue();
        if (iLangue != null) {
          HashMap<ItemRituel,Vector<ItemEvaluation>> lesItemsRituels = getItemsRituelsDeLangue(iLangue.getLangue());
          if (lesItemsRituels != null) {
            Vector<ItemRituel> listeRituels = new Vector<ItemRituel>();
            for(Entry<ItemRituel,Vector<ItemEvaluation>> entreeRituel : lesItemsRituels.entrySet()) 
              listeRituels.addElement(entreeRituel.getKey());
            _listeRituels.setModel(Vector2Model(listeRituels));
            _listeEvaluations.setModel(new DefaultListModel());
          }
        }  
      }
      if (evt.getSource() == _listeRituels) {
        ItemRituel iRituel = (ItemRituel)_listeRituels.getSelectedValue();
        if (iRituel != null) {
          Vector<ItemEvaluation> lesItemsEvaluations = getItemsEvaluationsDeLangueEtDeRituel(((ItemLangue)_listeLangues.getSelectedValue()).getLangue(), iRituel.getRituel());
          if (lesItemsEvaluations != null) {
            // tri des évaluations de la plus récente à la plus ancienne
            ArrayList<ParametreDeTri> lesParametres = new ArrayList<ParametreDeTri>();
            lesParametres.add(new ParametreDeTri(Evaluation.DATE_DESC, "Date récente->ancienne"));
            Comparator<ItemEvaluation> cp = ItemEvaluation.getComparator(lesParametres);
            Collections.sort(lesItemsEvaluations, cp);
            _listeEvaluations.setModel(Vector2Model(lesItemsEvaluations));
          }
        } else {
          _listeEvaluations.setModel(new DefaultListModel());
        }
      }
      ((TbiAdmin)_app).majPlugin(this);
    }
  }

  @Override
  public void setSelected(boolean selected) {
    if (_lesItems != null)
      for(Entry<ItemLangue,HashMap<ItemRituel,Vector<ItemEvaluation>>> entreeLangue : _lesItems.entrySet()) {
        ItemLangue itemLangue = entreeLangue.getKey();
        itemLangue.setSelected(selected && itemLangue.estPresentDansEvaluation());
      }
    majPlugin();
  }  
  
  @Override
  public void itemStateChanged(ItemEvent evt) {
    if (evt.getSource() == _cbLangues) 
        selectionneTousLesItems(_listeLangues,_cbLangues.isSelected());
    if (evt.getSource() == _cbRituels) 
        selectionneTousLesItems(_listeRituels,_cbRituels.isSelected());    
    super.itemStateChanged(evt);
    if (evt.getSource() instanceof CheckBox) {
      CheckBox cb = (CheckBox)evt.getSource();
      if (cb.getParent() instanceof ItemLangue) {
        ItemLangue item = (ItemLangue)cb.getParent();
        HashMap<ItemRituel,Vector<ItemEvaluation>> lesRituels = getItemsRituelsDeLangue(item.getLangue()); 
        if (lesRituels != null)
          for(Entry<ItemRituel,Vector<ItemEvaluation>> entreeRituel : lesRituels.entrySet()) {
            ItemRituel itemRituel = entreeRituel.getKey();
            if (item.isSelected() && itemRituel.estPresentDansEvaluation())
              itemRituel.setSelected(true);
            else 
              itemRituel.setSelected(false); 
        } 
      }
      if (cb.getParent() instanceof ItemRituel) {
        ItemRituel item = (ItemRituel)cb.getParent();
        Vector<ItemEvaluation> lesItemsEvaluations = getItemsEvaluationsDuRituel(item);
        if (lesItemsEvaluations != null) 
          for(int e = 0; e < lesItemsEvaluations.size(); e++) {
            ItemEvaluation iEval = lesItemsEvaluations.elementAt(e);
            if (item.isSelected() && iEval.estPresentDansEvaluation())
              iEval.setSelected(true);
            else 
              iEval.setSelected(false); 
          }
      }
      if (cb.getParent() instanceof ItemEvaluation) {
        ItemEvaluation item = (ItemEvaluation)cb.getParent();
        // rien à faire
      }
    }
  }
  
  private Vector<ItemLangue> getItemsLanguesSelectionnes() {
    ListModel liste = _listeLangues.getModel();
    Vector<ItemLangue> lesItemsLangues = new Vector<ItemLangue>();
    for(int t = 0; t < liste.getSize(); t++) {
      ItemLangue item = (ItemLangue)liste.getElementAt(t);
      if (item.isSelected())
        lesItemsLangues.addElement(item);  
    }
    return lesItemsLangues;
  } 

  private Vector<ItemRituel> getItemsRituelsDeLangueSelectionnes(ItemLangue langue) {
    Vector<ItemRituel> res = new Vector<ItemRituel>();
    HashMap<ItemRituel,Vector<ItemEvaluation>> entreeLangue = _lesItems.get(langue);
    if (entreeLangue != null)  
      for(Entry<ItemRituel,Vector<ItemEvaluation>> entreeRituel : entreeLangue.entrySet()) {
        ItemRituel item = entreeRituel.getKey();
        if (item.isSelected())
          res.addElement(item);
      }
    return res;      
  } 
  
  public Vector<ItemEvaluation> getLesItemsEvaluationsSelectionnes(boolean selected) {
    Vector<ItemEvaluation> res = new Vector<ItemEvaluation>();
    for(Entry<ItemLangue, HashMap<ItemRituel,Vector<ItemEvaluation>>> entreeLangue : _lesItems.entrySet()) 
      for(Entry<ItemRituel,Vector<ItemEvaluation>> entreeRituel : entreeLangue.getValue().entrySet()) {
        Vector<ItemEvaluation> lesItemsEvaluations =  entreeRituel.getValue();
        for(int i = 0; i < lesItemsEvaluations.size(); i++) {
          ItemEvaluation item = lesItemsEvaluations.elementAt(i);
          if ((selected && item.isSelected()) || !selected)
            res.addElement(item);
        }
      }
    return res;      
  } 
  
  @Override
	public boolean generationPDFPossible() {
    return (getItemsLanguesSelectionnes().size() > 0);
  }  
  
  private PdfPTable genereCartoucheParApplication(String langue, String rituel) {
    boolean francais = langue.equals("Francais");
    PdfPTable cartouche = new PdfPTable(new float[] {1f, 1f});
 		cartouche.setWidthPercentage(60);
 		cartouche.setHorizontalAlignment(com.itextpdf.text.Element.ALIGN_LEFT);
    Paragraph pClasse = new Paragraph("Classe : " + _app.getClasseSelectionnee().getNom(), FontFactory.getFont(FontFactory.HELVETICA, 10, com.itextpdf.text.Font.BOLD));
    pClasse.setAlignment(com.itextpdf.text.Element.ALIGN_LEFT);
 		PdfPCell cClasse = new PdfPCell(pClasse);
    cartouche.addCell(cClasse);
    Skin skin = getSkin("skin" + langue + ".jar");
    if (skin != null) {
      if (rituel.equals("Météorologie")) 
        rituel = skin.getTraduction("Meteo");
      if (rituel.equals("Absents/Présents")) 
        rituel = skin.getTraduction("ALaMaison") + "/" + skin.getTraduction("ALEcole");
    }
    Paragraph pRituel = new Paragraph(rituel, FontFactory.getFont(FontFactory.HELVETICA, 10));          
    PdfPCell cRituel = new PdfPCell(pRituel);
    cRituel.setRowspan(francais ? 2 : 3);
    cRituel.setVerticalAlignment(com.itextpdf.text.Element.ALIGN_MIDDLE);
    cRituel.setHorizontalAlignment(com.itextpdf.text.Element.ALIGN_CENTER);
    cartouche.addCell(cRituel);
    Paragraph pTitre = new Paragraph(_nomApplication, FontFactory.getFont(FontFactory.HELVETICA, 12));
    pTitre.setAlignment(com.itextpdf.text.Element.ALIGN_CENTER);
  	PdfPCell cTitre = new PdfPCell(pTitre);
    cartouche.addCell(cTitre);
    Paragraph pLangue = new Paragraph(langue, FontFactory.getFont(FontFactory.HELVETICA, 10));
    PdfPCell cLangue = new PdfPCell(pLangue);
  	cLangue.setBackgroundColor(_couleurFondTitre);
  	cLangue.setVerticalAlignment(com.itextpdf.text.Element.ALIGN_MIDDLE);
    if (!francais)
      cartouche.addCell(cLangue);
    cartouche.setSpacingBefore(10f);                  
    return cartouche;
  }

  protected String formateDate(Calendar date, String langue) {
    Skin skin = getSkin("skin" + langue + ".jar");
    String formatDate = "";
    String mmm = "";
    String dd = "";
    String jjj = "";
    if (skin != null) {
      formatDate = skin.getTraduction("FormatDate");
      mmm = skin.getTraduction(getIdMois(date.get(Calendar.MONTH)+1));
      jjj = skin.getTraduction(getIdJour(date.get(Calendar.DAY_OF_WEEK)));
      dd = skin.getTraduction("Date" + date.get(Calendar.DAY_OF_MONTH)); 
    }
    String mm = (date.get(Calendar.MONTH) < 9 ? "0" : "") + (date.get(Calendar.MONTH)+1);
    String aaaa = "" + date.get(Calendar.YEAR);
    formatDate = formatDate.replaceAll("dd", dd);
    formatDate = formatDate.replaceAll("jjj", jjj);
    formatDate = formatDate.replaceAll("mmm", mmm);
    formatDate = formatDate.replaceAll("aaaa", aaaa);
    formatDate = formatDate.replaceAll("mm", mm);
    return formatDate;
  }

  private PdfPTable genereTableauMeteo(String langue, Vector<EvaluationRituel> lesEvaluations) throws DocumentException, IOException {
    PdfPTable tableau = new PdfPTable(2);
  	tableau.setWidthPercentage(100);
  	tableau.setHorizontalAlignment(com.itextpdf.text.Element.ALIGN_LEFT);
  	tableau.setSpacingBefore(15f);
    com.itextpdf.text.Font policeDateEval = new com.itextpdf.text.Font(com.itextpdf.text.Font.FontFamily.HELVETICA, 10, com.itextpdf.text.Font.BOLD);  	
   	for(int e = 0; e < lesEvaluations.size(); e++) {
      EvaluationRituel eval = lesEvaluations.elementAt(e);
      if (!eval.contientMeteo())
        continue;
      String dateEval = formateDate(eval.getDateStart(), langue);
      Phrase pDate = new Phrase(dateEval, policeDateEval);
      PdfPCell cDate = new PdfPCell(pDate);
      cDate.setHorizontalAlignment(com.itextpdf.text.Element.ALIGN_CENTER);
      cDate.setVerticalAlignment(com.itextpdf.text.Element.ALIGN_MIDDLE);
      tableau.addCell(cDate);
      String lesDonneesMeteo = "";
      Skin skin = getSkin("skin" + langue + ".jar");
      if (eval.getTemperature() != null && skin != null)
        lesDonneesMeteo += skin.getTraduction(eval.getTemperature());
      if (eval.getCiel() != null && skin != null)
        lesDonneesMeteo += "\n" + skin.getTraduction(eval.getCiel());
      if (eval.getPrecipitation() != null && skin != null)
        lesDonneesMeteo += "\n" + skin.getTraduction(eval.getPrecipitation());
      if (eval.getVent() != null && skin != null)
        lesDonneesMeteo += "\n" + skin.getTraduction(eval.getVent());
      PdfPCell cDonneesMeteo = new PdfPCell(new Paragraph(lesDonneesMeteo, _policePDFReponses));
      tableau.addCell(cDonneesMeteo);
    }
    return tableau;
  }   

    private PdfPTable genereTableauPresence(String langue, Vector<EvaluationRituel> lesEvaluations) throws DocumentException, IOException {
    com.itextpdf.text.Font policeDateEval = new com.itextpdf.text.Font(com.itextpdf.text.Font.FontFamily.HELVETICA, 10, com.itextpdf.text.Font.BOLD);
    PdfPTable tableau = new PdfPTable(3);
  	tableau.setWidthPercentage(100);
  	tableau.setHorizontalAlignment(com.itextpdf.text.Element.ALIGN_LEFT);
  	tableau.setSpacingBefore(15f);
   	for(int e = 0; e < lesEvaluations.size(); e++) {
      EvaluationRituel eval = lesEvaluations.elementAt(e);
      if (!eval.contientPresence())
        continue;
      String dateEval = formateDate(eval.getDateStart(), langue);
      Phrase pDate = new Phrase(dateEval, policeDateEval);
      PdfPCell cDate = new PdfPCell(pDate);
      cDate.setRowspan(2);
      cDate.setHorizontalAlignment(com.itextpdf.text.Element.ALIGN_CENTER);
      cDate.setVerticalAlignment(com.itextpdf.text.Element.ALIGN_MIDDLE);
      tableau.addCell(cDate);

      Skin skin = getSkin("skin" + langue + ".jar");
      String sALaMaison =  (skin != null ? skin.getTraduction("ALaMaison") : "A la maison"); 
      Phrase pALaMaison = new Phrase(sALaMaison, policeDateEval);
      PdfPCell cALaMaison = new PdfPCell(pALaMaison);
      cALaMaison.setHorizontalAlignment(com.itextpdf.text.Element.ALIGN_CENTER);
      cALaMaison.setVerticalAlignment(com.itextpdf.text.Element.ALIGN_MIDDLE);
      tableau.addCell(cALaMaison);

      String sALEcole = (skin != null ? skin.getTraduction("ALEcole") : "A l'école"); 
      Phrase pALEcole = new Phrase(sALEcole, policeDateEval);
      PdfPCell cALEcole = new PdfPCell(pALEcole);
      cALEcole.setHorizontalAlignment(com.itextpdf.text.Element.ALIGN_CENTER);
      cALEcole.setVerticalAlignment(com.itextpdf.text.Element.ALIGN_MIDDLE);
      tableau.addCell(cALEcole);
      
      String lesAbsents = "";
      if (eval.getElevesMaison() != null) {
        StringTokenizer st = new StringTokenizer(eval.getElevesMaison(), ","); 
        while(st.hasMoreTokens()) {
          Eleve eleve = _laClasseSelectionnee.getEleveById(st.nextToken());
          lesAbsents += eleve.getPrenom() + " " + eleve.getNom() + (st.hasMoreTokens() ? "\n" : "");
        } 
      }
      PdfPCell cAbsents = new PdfPCell(new Paragraph(lesAbsents, _policePDFReponses));
      tableau.addCell(cAbsents);
      String lesPresents = "";
      if (eval.getElevesEcole() != null) {
        StringTokenizer st = new StringTokenizer(eval.getElevesEcole(), ",");
        while(st.hasMoreTokens()) {
          Eleve eleve = _laClasseSelectionnee.getEleveById(st.nextToken());
          lesPresents += eleve.getPrenom() + " " + eleve.getNom() + (st.hasMoreTokens() ? "\n" : "");
        }
      }
      PdfPCell cPresents = new PdfPCell(new Paragraph(lesPresents, _policePDFReponses));
      tableau.addCell(cPresents);      
    }
    return tableau;
  }   

  @Override
  public ObjetPDF genererPDF(ObjetPDF oPDF) throws DocumentException, FileNotFoundException, IOException  {
    oPDF = super.genererPDF(oPDF);
    Vector<ItemLangue> lesLanguesSelectionnees = getItemsLanguesSelectionnes();
    for(int l = 0; l < lesLanguesSelectionnees.size(); l++) {
      ItemLangue iLangue = lesLanguesSelectionnees.elementAt(l);
      String langue = iLangue.getLangue(); 
      Vector<ItemRituel> lesRituelsSelectionnes = getItemsRituelsDeLangueSelectionnes(iLangue);
      for(int r = 0; r < lesRituelsSelectionnes.size(); r++) {
        String rituel = lesRituelsSelectionnes.elementAt(r).getRituel(); 
		    oPDF.document.add(genereCartoucheParApplication(langue, rituel));
	      // definition des évaluations sélectionnées
        Vector<EvaluationRituel> lesEvaluationsRituel = new Vector<EvaluationRituel>();
        for(Entry<ItemRituel,Vector<ItemEvaluation>> entreeRituel : getItemsRituelsDeLangue(langue).entrySet()) {    
          Vector<ItemEvaluation> lesItemsEvaluations = getItemsEvaluationsDuRituel(entreeRituel.getKey());
 	        for(int i = 0; i < lesItemsEvaluations.size(); i++) {
 	          ItemEvaluation item = lesItemsEvaluations.elementAt(i);
 	          if (item.isSelected() && !lesEvaluationsRituel.contains((EvaluationRituel)item.getEvaluation()))
 	            lesEvaluationsRituel.addElement((EvaluationRituel)item.getEvaluation());
 	        }
        }
        // tri des évaluations de la plus ancienne à la plus récente
        ArrayList<ParametreDeTri> lesParametres = new ArrayList<ParametreDeTri>();
        lesParametres.add(new ParametreDeTri(Evaluation.DATE_ASC, "Date ancienne->récente"));
        Comparator<Evaluation> cp = Evaluation.getComparator(lesParametres);
        Collections.sort(lesEvaluationsRituel, cp);
      // genere les données suivant le rituel
        if (rituel.equals("Météorologie"))
          oPDF.document.add(genereTableauMeteo(langue, lesEvaluationsRituel));
        if (rituel.equals("Absents/Présents")) 
          oPDF.document.add(genereTableauPresence(langue, lesEvaluationsRituel));
        if (r < lesRituelsSelectionnes.size()-1) 
          oPDF.document.newPage();
      }
      if (l < lesLanguesSelectionnees.size()-1) 
        oPDF.document.newPage();
    }
    return oPDF;        
  }

  @Override
  public ObjetPDF genererPDF(ObjetPDF oPDF, Eleve eleve) throws DocumentException, FileNotFoundException, IOException  {
    return super.genererPDF(oPDF, eleve);
    // on ne fait rien, pas d'info spécifique à un élève
  }
  
  @Override
  public void majPlugin() {
    super.majPlugin();
    _scLangues.repaint();
    _scRituels.repaint();
    _scEvaluations.repaint();
  } 
  
}